--
connect JEMUSER/JEMPASSWD;

------------------------------------------------------------
--        
create or replace package  JEMDatabus
  AUTHID  DEFINER  as
  procedure  setDatabusProperties(dfbusname  IN VARCHAR2,
               tokttldiff      NUMBER,
	       tokttlcalldiff  NUMBER,
	       tokttldatdiff  NUMBER,
	       rxnttldiff      NUMBER,
	       gccycle         NUMBER);
  procedure  setTokttldiff(
               dfbusname  IN VARCHAR2,
               tokttldiff      NUMBER);
  procedure  setTokttlcalldiff(
               dfbusname  IN VARCHAR2,
               tokttlcalldiff       NUMBER);
  procedure  setTokttldatdiff(
               dfbusname  IN VARCHAR2,
               tokttldatdiff      NUMBER);
  procedure  setTokclnttldiff(
               dfbusname  IN VARCHAR2,
               tokclnttldiff      NUMBER);
  procedure  setRxnttldiff(
               dfbusname  IN VARCHAR2,
               rxnttldiff       NUMBER);
  procedure  setGCcycle(
               dfbusname  IN VARCHAR2,
               gccycle       NUMBER);
  procedure  advanceEpoch(dfbusname  IN VARCHAR2);
  procedure  quiteDatabus(dfbusname  IN VARCHAR2);
  procedure  purge(dfbusname  IN VARCHAR2);
  procedure  addRole(
                dbusname                    IN VARCHAR2  DEFAULT NULL,
                schemausrid                 IN VARCHAR2,
                ctrid                       IN VARCHAR2,
                roleid                      IN VARCHAR2,
                description                 IN VARCHAR2  DEFAULT NULL);
  procedure  removeRole(
                dbusname                    IN VARCHAR2  DEFAULT NULL,
                schemausrid                 IN VARCHAR2,
                ctrid                       IN VARCHAR2  DEFAULT NULL,
                roleid                      IN VARCHAR2  DEFAULT NULL);
--  procedure  createDatabusQue(
--                dfbusname                   IN     VARCHAR2  DEFAULT NULL, 
--                description                 IN     VARCHAR2  DEFAULT NULL,
--                max_retries                 IN     NUMBER    DEFAULT 1,
--                retry_delay                 IN     NUMBER    DEFAULT 0,
--                retention_time              IN     NUMBER    DEFAULT 0,
--                gccycle                     IN     NUMBER    DEFAULT 10000);
--  procedure  dropDatabusQue(dfbusname  IN VARCHAR2  DEFAULT NULL);
  procedure  createDatabusTpc(
                dfbusname                   IN     VARCHAR2  DEFAULT NULL, 
                description                 IN     VARCHAR2  DEFAULT NULL,
                max_retries                 IN     NUMBER    DEFAULT 1,
                retry_delay                 IN     NUMBER    DEFAULT 0,
                retention_time              IN     NUMBER    DEFAULT 0,
                gccycle                     IN     NUMBER    DEFAULT 10000);
  procedure  dropDatabusTpc(dfbusname  IN VARCHAR2  DEFAULT NULL);
  procedure  createAppGroupSubscriber(
                dbusname   IN     VARCHAR2,
                subname    IN     VARCHAR2 DEFAULT  'JEMSUB');
  procedure  dropAppGroupSubscriber(
                dbusname  IN     VARCHAR2,
                subname   IN     VARCHAR2 DEFAULT  'JEMSUB');
end  JEMDatabus;
/
------------------------------------------------------------
------------------------------------------------------------
create or replace package body  JEMDatabus as

  procedure  createDfbus(dbusname  VARCHAR2);
  procedure  dropDfbus(dbusname  IN VARCHAR2);
  procedure  createReg(dbusname  IN VARCHAR2);
  procedure  dropReg(dbusname  IN VARCHAR2);
  procedure  createProcess(dbusname  IN VARCHAR2);
  procedure  dropProcess(dbusname  IN VARCHAR2);
  procedure  createRxn(dbusname  IN VARCHAR2);
  procedure  dropRxn(dbusname  IN VARCHAR2);
  procedure  createMatchTup(dbusname  IN VARCHAR2);
  procedure  dropMatchTup(dbusname  IN VARCHAR2);
  procedure  createToken(dbusname  IN VARCHAR2);
  procedure  dropToken(dbusname  IN VARCHAR2);
  procedure  createTrk(dbusname  IN VARCHAR2);
  procedure  dropTrk(dbusname  IN VARCHAR2);
  procedure  createPrv(dbusname  IN VARCHAR2);
  procedure  dropPrv(dbusname  IN VARCHAR2);
  procedure  initTabs(
                instid                      IN VARCHAR2,
                dbusname                    IN VARCHAR2,
                description                 IN VARCHAR2  DEFAULT NULL,
                max_retries                 IN NUMBER    DEFAULT 1,
                retry_delay                 IN NUMBER    DEFAULT 0,
                gccycle                     IN NUMBER    DEFAULT 10000);
  procedure  grantTabs(dbusname  IN VARCHAR2);
  procedure  createTabSynonyms(dbusname  IN VARCHAR2);
  procedure  dropTabSynonyms(dbusname  IN VARCHAR2);
  procedure  createVwNtfRegistration(dbusname  IN VARCHAR2);
  procedure  dropVwNtfRegistration(dbusname  IN VARCHAR2);
  procedure  createVwProcess(dbusname  IN VARCHAR2);
  procedure  dropVwProcess(dbusname  IN VARCHAR2);
  procedure  createVwReaction(dbusname  IN VARCHAR2);
  procedure  dropVwReaction(dbusname  IN VARCHAR2);
  procedure  createVwReactionTemplate(dbusname  IN VARCHAR2);
  procedure  dropVwReactionTemplate(dbusname  IN VARCHAR2);
  procedure  createVwActiveData(dbusname  IN VARCHAR2);
  procedure  dropVwActiveData(dbusname  IN VARCHAR2);
  procedure  createVwTracking(dbusname  IN VARCHAR2);
  procedure  dropVwTracking(dbusname  IN VARCHAR2);
  procedure  createVwDatabus(dbusname  IN VARCHAR2);
  procedure  dropVwDatabus(dbusname  IN VARCHAR2);
  procedure  createQues(
                dbusname                    IN     VARCHAR2,
                max_retries                 IN     NUMBER    DEFAULT 1,
                retry_delay                 IN     NUMBER    DEFAULT 0,
                retention_time              IN     NUMBER    DEFAULT 0);
  procedure  createTpcs(
                dbusname                    IN     VARCHAR2,
                max_retries                 IN     NUMBER    DEFAULT 1,
                retry_delay                 IN     NUMBER    DEFAULT 0,
                retention_time              IN     NUMBER    DEFAULT 0);
  procedure  grantQues(dbusname  IN VARCHAR2);
  procedure  stopMatchQue(dbusname  IN VARCHAR2);
  procedure  stopSchedQue(dbusname  IN VARCHAR2);
  procedure  stopDirectQue(dbusname  IN VARCHAR2);
  procedure  stopForeignQue(dbusname  IN VARCHAR2);
  procedure  stopExceptionQue(dbusname  IN VARCHAR2);
  procedure  dropSubMatchQue(dbusname  IN VARCHAR2,                 
                             subname   IN VARCHAR2 DEFAULT  'JEMSUB');
  procedure  dropSubSchedQue(dbusname  IN VARCHAR2,
                             subname   IN VARCHAR2 DEFAULT  'JEMSUB');
  procedure  dropSubDirectQue(dbusname  IN VARCHAR2,
                             subname   IN VARCHAR2 DEFAULT  'JEMSUB');
  procedure  dropSubForeignQue(dbusname  IN VARCHAR2,
                               subname   IN VARCHAR2 DEFAULT  'JEMSUB');
  procedure  dropMatchQue(dbusname  IN VARCHAR2);
  procedure  dropSchedQue(dbusname  IN VARCHAR2);
  procedure  dropDirectQue(dbusname  IN VARCHAR2);
  procedure  dropForeignQue(dbusname  IN VARCHAR2);
  procedure  dropQueTable(dbusname  IN VARCHAR2);
  procedure  dropQues(dbusname  IN VARCHAR2);
  procedure  dropTpcs(dbusname  IN VARCHAR2);


---------------------------------
  procedure  createDatabusQue(
        dfbusname                   IN     VARCHAR2  DEFAULT NULL, 
        description                 IN     VARCHAR2  DEFAULT NULL,
        max_retries                 IN     NUMBER    DEFAULT 1,
        retry_delay                 IN     NUMBER    DEFAULT 0,
        retention_time              IN     NUMBER    DEFAULT 0,
        gccycle                     IN     NUMBER    DEFAULT 10000) is
    instid        VARCHAR2(50);
    dbusname      VARCHAR2(100);
    destdbusname  VARCHAR2(100);
  begin
    if dfbusname is null then
      dbusname     := '';
      destdbusname := '';
    else
      dbusname     := dfbusname;
      destdbusname := dfbusname;
    end if;

    --
    if length(dfbusname) > 20 then
      raise_application_error(-20001, 'Length of dfbusname is > 20');
    end if;

    --
    select instid into instid from TabSystem;

    --
    createDfbus(dbusname);
    createReg(dbusname);
    createProcess(dbusname);
    createRxn(dbusname);
    createMatchTup(dbusname);
    createToken(dbusname);
    createTrk(dbusname);
    createPrv(dbusname);

    grantTabs(dbusname);

    createTabSynonyms(dbusname);

    initTabs(instid, 
             dbusname,
             description,
             max_retries,
             retry_delay,
             gccycle);
    
    createVwNtfRegistration(dbusname);
    createVwProcess(dbusname);
    createVwReaction(dbusname);
    createVwReactionTemplate(dbusname);
    createVwActiveData(dbusname);
    createVwTracking(dbusname);
    createVwDatabus(dbusname);

    createQues(destdbusname, 
               max_retries,
               retry_delay,
               retention_time);

    --TODO: remove this
    --grantQues(destdbusname);
  end;
---------------------------------
  procedure  dropDatabusQue(dfbusname  IN VARCHAR2  DEFAULT NULL) is
    dbusname      VARCHAR2(100);
    destdbusname  VARCHAR2(100);
  begin
    if dfbusname is null then
      dbusname     := '';
      destdbusname := '';
    else
      dbusname     := dfbusname;
      destdbusname := dfbusname;
    end if;

    --
    dropDfbus(dbusname);
    dropReg(dbusname);
    dropProcess(dbusname);
    dropRxn(dbusname);
    dropMatchTup(dbusname);
    dropToken(dbusname);
    dropTrk(dbusname);
    dropPrv(dbusname);
    dropTabSynonyms(dbusname);

    dropVwNtfRegistration(dbusname);
    dropVwProcess(dbusname);
    dropVwReaction(dbusname);
    dropVwReactionTemplate(dbusname);
    dropVwActiveData(dbusname);
    dropVwTracking(dbusname);
    dropVwDatabus(dbusname);

    dropQues(destdbusname);
  end;
---------------------------------
  procedure  createDatabusTpc(        
        dfbusname                   IN     VARCHAR2  DEFAULT NULL, 
        description                 IN     VARCHAR2  DEFAULT NULL,
        max_retries                 IN     NUMBER    DEFAULT 1,
        retry_delay                 IN     NUMBER    DEFAULT 0,
        retention_time              IN     NUMBER    DEFAULT 0,
        gccycle                     IN     NUMBER    DEFAULT 10000) is
    instid        VARCHAR2(50);
    dbusname      VARCHAR2(100);
    destdbusname  VARCHAR2(100);
  begin
    if dfbusname is null then
      dbusname     := '';
      destdbusname := '';
    else
      dbusname     := dfbusname;
      destdbusname := dfbusname;
    end if;

    --
    if length(dfbusname) > 20 then
      raise_application_error(-20001, 'Length of dfbusname is > 20');
    end if;

    --
    select instid into instid from TabSystem;

    --
    createDfbus(dbusname);
    createReg(dbusname);
    createProcess(dbusname);
    createRxn(dbusname);
    createMatchTup(dbusname);
    createToken(dbusname);
    createTrk(dbusname);
    createPrv(dbusname);

    grantTabs(dbusname);
    createTabSynonyms(dbusname);

    initTabs(instid, 
             dbusname,
             description,
             max_retries,
             retry_delay,
             gccycle);

    createVwNtfRegistration(dbusname);
    createVwProcess(dbusname);
    createVwReaction(dbusname);
    createVwReactionTemplate(dbusname);
    createVwActiveData(dbusname);
    createVwTracking(dbusname);
    createVwDatabus(dbusname);

    createTpcs(destdbusname,
               max_retries,
               retry_delay,
               retention_time);

    --TODO: remove this
    --grantQues(destdbusname);
  end;
---------------------------------
  procedure  dropDatabusTpc(dfbusname  IN VARCHAR2  DEFAULT NULL) is
    dbusname      VARCHAR2(100);
    destdbusname  VARCHAR2(100);
  begin
    if dfbusname is null then
      dbusname     := '';
      destdbusname := '';
    else
      dbusname     := dfbusname;
      destdbusname := dfbusname;
    end if;

    --
    dropDfbus(dbusname);
    dropReg(dbusname);
    dropProcess(dbusname);
    dropRxn(dbusname);
    dropMatchTup(dbusname);
    dropToken(dbusname);
    dropTrk(dbusname);
    dropPrv(dbusname);
    dropTabSynonyms(dbusname);

    dropVwNtfRegistration(dbusname);
    dropVwProcess(dbusname);
    dropVwReaction(dbusname);
    dropVwReactionTemplate(dbusname);
    dropVwActiveData(dbusname);
    dropVwTracking(dbusname);
    dropVwDatabus(dbusname);

    dropTpcs(destdbusname);
  end;
---------------------------------
  procedure  setDatabusProperties(dfbusname  IN VARCHAR2,
              tokttldiff      NUMBER,
	      tokttlcalldiff  NUMBER,
	      tokttldatdiff  NUMBER,
	      rxnttldiff      NUMBER,
	      gccycle         NUMBER)  is
   sqlstmt1  VARCHAR2(1000);
   schemaname  VARCHAR2(100) := dfbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
     'update  TabDFB' ||
     schemaname         || '  ' ||
     '   set  tokttldiff     = :dat1, ' ||
     '        tokttlcalldiff = :dat2, ' ||
     '        tokttldatdiff = :dat3, ' ||
     '        rxnttldiff     = :dat4, ' ||
     '        gccycle        = :dat5  ';

    execute immediate sqlstmt1
      using  tokttldiff, tokttlcalldiff, tokttldatdiff,
             rxnttldiff, gccycle;

    commit;
  end;
---------------------------------
  procedure  setTokttldiff(
              dfbusname  IN VARCHAR2, tokttldiff      NUMBER) is
   sqlstmt1  VARCHAR2(1000);
   schemaname  VARCHAR2(100) := dfbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
     'update  TabDFB' ||
     schemaname         || '  ' ||
     'set  tokttldiff = :dat1';

    execute immediate sqlstmt1  using  tokttldiff;

    commit;
  end;
---------------------------------
  procedure  setTokttlcalldiff(
       dfbusname  IN VARCHAR2, tokttlcalldiff  NUMBER) is
   sqlstmt1  VARCHAR2(1000);
   schemaname  VARCHAR2(100) := dfbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
     'update  TabDFB' ||
     schemaname         || '  ' ||
     'set  tokttlcalldiff = :dat1';

    execute immediate sqlstmt1  using  tokttlcalldiff;

    commit;
  end;
---------------------------------
  procedure  setTokttldatdiff(
              dfbusname  IN VARCHAR2, tokttldatdiff  NUMBER)  is
    sqlstmt1  VARCHAR2(1000);
    schemaname  VARCHAR2(100) := dfbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
     'update  TabDFB' ||
     schemaname    || '  ' ||
     'set  tokttldatdiff = :dat1';

    execute immediate sqlstmt1  using  tokttldatdiff;

    commit;
  end;
---------------------------------
  procedure  setTokclnttldiff(
              dfbusname  IN VARCHAR2, tokclnttldiff      NUMBER) is
   sqlstmt1  VARCHAR2(1000);
   schemaname  VARCHAR2(100) := dfbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
     'update  TabDFB' ||
     schemaname         || '  ' ||
     'set  tokclnttldiff = :dat1';

    execute immediate sqlstmt1  using  tokclnttldiff;

    commit;
  end;
---------------------------------
  procedure  setRxnttldiff(              
               dfbusname  IN VARCHAR2, rxnttldiff  NUMBER)  is
    sqlstmt1  VARCHAR2(1000);
    schemaname  VARCHAR2(100) := dfbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
     'update  TabDFB' ||
     schemaname         || '  ' ||
     ' set  rxnttldiff     = :dat1';

    execute immediate sqlstmt1  using  rxnttldiff;

    commit;
  end;
---------------------------------
  procedure  setGCcycle(
              dfbusname  IN VARCHAR2, gccycle  NUMBER)  is
    sqlstmt1  VARCHAR2(1000);
    schemaname  VARCHAR2(100) := dfbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
     'update  TabDFB' ||
     schemaname         || '  ' ||
     'set  gccycle = :dat1';

    execute immediate sqlstmt1  using  gccycle;

    commit;
  end;
---------------------------------
  procedure  advanceEpoch(dfbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(1000);
    schemaname  VARCHAR2(100) := dfbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
     'update  TabDFB' ||
     schemaname         || '  ' ||
     'set  epochnext = epochnext + 1';

    execute immediate sqlstmt1;

    commit;
  end;
---------------------------------
  procedure  quiteDatabus(dfbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(1000);
    schemaname  VARCHAR2(100) := dfbusname;
    state   VARCHAR2(20) := 'DFBST_BLOCK';
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
     'update  TabDFB' ||
     schemaname         || '  ' ||
     'set  state = :dat1';

    execute immediate sqlstmt1 using  state;

    commit;
  end;
---------------------------------
  procedure  purge(dfbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(1000);
    sqlstmt2  VARCHAR2(1000);
    sqlstmt3  VARCHAR2(1000);
    sqlstmt4  VARCHAR2(1000);
    sqlstmt5  VARCHAR2(1000);
    sqlstmt6  VARCHAR2(1000);
    sqlstmt7  VARCHAR2(1000);
    sqlstmt8  VARCHAR2(1000);
    schemaname  VARCHAR2(100) := dfbusname;
    dfbusepoch  NUMBER;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
     'update  TabDFB' ||
     schemaname         || '  ' ||
     'set  epoch = epochnext';
        
    execute immediate sqlstmt1;

    --
    sqlstmt2 :=
     'select  epoch'   ||
     '  from TabDFB' ||
     schemaname        ;

    execute immediate sqlstmt2 into  dfbusepoch;

    --
    sqlstmt3 :=
     'delete from  TabPRS' ||
     schemaname                || '  ' ||
     '  where epoch < :dat1';

    execute immediate sqlstmt3 using  dfbusepoch;

    --
    sqlstmt4 :=
     'delete from  TabRXN' ||
     schemaname            || '  ' ||
     'where epoch < :dat1';

    execute immediate sqlstmt4 using  dfbusepoch;

    --
    sqlstmt5 :=
     'delete from  TabRTL' ||
     schemaname                 || '  ' ||
     '  where epoch < :dat1';

    execute immediate sqlstmt5 using  dfbusepoch;

    --
    sqlstmt6 :=
     'delete from  TabTOK' ||
     schemaname              || '  ' ||
     'where epoch < :dat1';

    execute immediate sqlstmt6 using  dfbusepoch;

    --
    sqlstmt7 :=
     'delete from  TabTRK' ||
     schemaname            || '  ' ||
     'where epoch < :dat1';

    execute immediate sqlstmt7 using  dfbusepoch;

    --
    --Purge Queues

    commit;
  end;
---------------------------------
  procedure  createDfbus(dbusname  IN VARCHAR2) is
    sqlstmt  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;
    sqlstmt :=
    'create table'        ||
             '  TabDFB'   || 
             schemaname   || '  ' ||
	     ' (instid         VARCHAR2(50)  PRIMARY KEY,    ' ||
	     ' version         VARCHAR2(20),                 ' ||
	     ' description     VARCHAR2(2000),               ' ||
	     ' scn             NUMBER  ,                     ' ||
	     ' sysiid          VARCHAR2(50),                 ' ||
	     ' sysaid          VARCHAR2(150),                ' ||
	     ' glbiid          VARCHAR2(50),                 ' ||
	     ' glbaid          VARCHAR2(150),                ' ||
	     ' ixnaid          VARCHAR2(150),                ' ||
	     ' maxrxnretry     NUMBER,                       ' ||
	     ' state           VARCHAR2(30),                 ' ||
	     ' creatdate       VARCHAR2(30),                 ' ||
	     ' tokttldiff      NUMBER,                       ' ||
	     ' tokttlcalldiff  NUMBER,                       ' ||
	     ' tokttldatdiff  NUMBER,                       ' ||
	     ' tokclnttldiff   NUMBER,                       ' ||
	     ' rxnttldiff      NUMBER,                       ' ||
	     ' gccycle         NUMBER,                       ' ||
             ' epoch           NUMBER,                       ' ||
             ' epochnext       NUMBER)                       ';

    begin
      execute immediate sqlstmt;
    exception
      when others then
        raise_application_error(-20001, 'Databus creation failed; Databus already exists');
    end;
  end;
---------------------------------
  procedure  dropDfbus(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;
    sqlstmt1 :=
    'drop table'          ||
             '  TabDFB' || 
             schemaname;
    begin
      execute immediate sqlstmt1;
    exception
      when others then
       dbms_output.put_line('EXC: dropDfbus1');
    end;
    --
    sqlstmt2 :=
    'drop public synonym'   ||
             '  TabDFB'   || 
             schemaname;
    begin
      execute immediate sqlstmt2;
    exception
      when others then 
       dbms_output.put_line('EXC: dropDfbus2');
    end;
  end;
---------------------------------
  procedure  createReg(dbusname  IN VARCHAR2) is
    sqlstmt  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;
    sqlstmt :=
    'create table'        ||
             '  TabNTF'   || 
             schemaname   || '  ' ||
	      '(key              VARCHAR2(100)  PRIMARY KEY, ' ||
              'tschema           VARCHAR2(100),              ' ||
              'tname             VARCHAR2(200),              ' ||
              'name              VARCHAR2(200),              ' ||
              'excname           VARCHAR2(200),              ' ||
              'payloadtype       VARCHAR2(100),              ' ||
              'type              VARCHAR2(50),               ' ||
              'op                VARCHAR2(50),               ' ||
              'dir               VARCHAR2(50),               ' ||
              'tconsname         VARCHAR2(200),              ' ||
              'msgselector       VARCHAR2(4000),             ' ||
              'userId            VARCHAR2(100),              ' ||
              'instid            VARCHAR2(100),              ' ||
              'dfbusname         VARCHAR2(100),              ' ||
              'objname           VARCHAR2(200),              ' ||
              'implid            VARCHAR2(200),              ' ||
              'homintfname       VARCHAR2(200),              ' ||
              'remintfname       VARCHAR2(200),              ' ||
              'flags             NUMBER)';	 
    execute immediate sqlstmt;
  end;
---------------------------------
  procedure  dropReg(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;
    sqlstmt1 :=
    'drop table'           ||
             '  TabNTF'    || 
             schemaname;
    begin
      execute immediate sqlstmt1;
    exception
      when others then
       dbms_output.put_line('EXC: dropReg1');
    end;
    --
    sqlstmt2 :=
    'drop public synonym'   ||
             '  TabNTF'   || 
             schemaname;
    begin
      execute immediate sqlstmt2;
    exception
      when others then
       dbms_output.put_line('EXC: dropReg2');
    end;
  end;
---------------------------------
  procedure  createProcess(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    sqlstmt3  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'create sequence'        ||
             '  SeqPRS'  || 
             schemaname      || '  ' ||
            'START WITH 1';

      execute immediate sqlstmt1;

    --
    sqlstmt2 :=
    'create table'           ||
             '  TabPRS'  || 
             schemaname      || '  ' ||
             '(prsseq               NUMBER,                 ' ||
	     ' iid                  VARCHAR2(50)  NOT NULL, ' ||  
	     ' aid                  VARCHAR2(150),          ' ||   
	     ' retiid               VARCHAR2(50),           ' ||
	     ' retaid               VARCHAR2(150),          ' ||
	     ' handle                  BLOB,                   ' ||
             ' handlelen               NUMBER,                 ' ||
	     ' rethandle               BLOB,                   ' ||
             ' rethandlelen            NUMBER,                 ' ||
	     ' prspeid              VARCHAR2(100),          ' ||   
	     ' funpolytup           BLOB,                   ' ||
             ' funpolytuplen        NUMBER,                 ' ||
	     ' retpolytup           BLOB,                   ' ||
             ' retpolytuplen        NUMBER,                 ' ||
	     ' excretpolytup        BLOB,                   ' ||
             ' excretpolytuplen     NUMBER,                 ' ||
	     ' cmpltag              VARCHAR2(250),          ' ||
	     ' callindx             NUMBER,                 ' ||        
	     ' state                VARCHAR2(50),           ' ||            
	     ' flags                NUMBER,                 ' ||     
	     ' prsstart             VARCHAR2(30),           ' ||
	     ' prsend               VARCHAR2(30),           ' ||
	     ' ixnoriginatorusrid   VARCHAR2(50),           ' ||
             ' epoch                NUMBER,                 ' ||
	     ' PRIMARY KEY (iid, aid))';

      execute immediate sqlstmt2;

    --
    sqlstmt3 :=
    'create unique index'  ||
             '  Idx1Prs'   || 
             schemaname    || '  ' ||
            'on TabPRS' ||
             schemaname    || '  ' ||
            '(prsseq)';

      execute immediate sqlstmt3;
  end;
---------------------------------
  procedure  dropProcess(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    sqlstmt1 :=
    'drop table'           ||
             '  TabPRS'    || 
             schemaname;

    begin
      execute immediate sqlstmt1;
    exception
      when others then
       dbms_output.put_line('EXC: dropProcess1');
    end;

    --
    sqlstmt2 :=
    'drop sequence'           ||
             '  SeqPRS'   || 
             schemaname;

    begin
      execute immediate sqlstmt2;
    exception
      when others then
       dbms_output.put_line('EXC: dropProcess2');
    end;
  end;
---------------------------------
  procedure  createRxn(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    sqlstmt3  VARCHAR2(4000);
    sqlstmt4  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'create sequence'        ||
             '  SeqRXN'      || 
             schemaname      || '  ' ||
            'START WITH 1';

      execute immediate sqlstmt1;

    --
    sqlstmt2 :=
    'create table'        ||
             '  TabRXN'   || 
             schemaname   || '  ' || 
	   '(rxnseq           NUMBER,              ' ||
	   ' iid              VARCHAR2(50)  NOT NULL,   ' || 
	   ' aid              VARCHAR2(150),       ' ||  
	   ' rid              VARCHAR2(100),       ' ||  
	   ' recursid         NUMBER,              ' ||  
	   ' handle              BLOB,                ' ||
           ' handlelen           NUMBER,	           ' ||
	   ' prspeid          VARCHAR2(100),       ' ||  
	   ' rxnpeid          VARCHAR2(100),       ' ||  
	   ' grpid            VARCHAR2(100),       ' ||  
	   ' vid              NUMBER,              ' ||  
           ' funpolytup       BLOB,                ' ||
           ' funpolytuplen    NUMBER,              ' ||
	   ' totmattups       NUMBER,              ' ||
           ' mattupsprops     BLOB,                ' ||
           ' mattupspropslen  NUMBER,              ' ||
	   ' retrycnt         NUMBER,              ' ||  
	   ' state            VARCHAR2(50),        ' || 
	   ' status           VARCHAR2(50),        ' || 
	   ' type             VARCHAR2(50),        ' ||     
	   ' flags            NUMBER,              ' ||      
	   ' rxnpri           NUMBER,              ' ||      
	   ' rxnttl           VARCHAR2(30),        ' ||
	   ' descr            VARCHAR2(2000),      ' ||
	   ' rxndate          NUMBER,              ' ||           
           ' rxnstart         VARCHAR2(30),        ' ||
           ' rxnend           VARCHAR2(30),        ' ||
	   ' schemausrid      VARCHAR2(50),        ' ||
           ' schemamsgid      VARCHAR2(50),        ' ||
           ' auxctx           BLOB,                ' || 
	   ' auxctxlen        NUMBER,              ' ||
           ' epoch            NUMBER,              ' ||
	   ' tokttldiff       NUMBER,              ' ||
           ' tokttlcalldiff   NUMBER,              ' ||
           ' tokttldatdiff   NUMBER,              ' ||
	   ' tokclnttldiff    NUMBER,              ' ||
	   ' rxnttldiff       NUMBER,              ' ||
	   ' PRIMARY KEY (iid, aid, rid, recursid))';

      execute immediate sqlstmt2;

    --
    sqlstmt3 :=
    'create unique index'  ||
             '  Idx1RXN'   || 
             schemaname    || '  ' ||
            'on TabRXN'    ||
             schemaname    || '  ' ||
            '(iid, aid, rid, recursid, prspeid, rxnpeid, grpid, state)';

      execute immediate sqlstmt3;

    --
    sqlstmt4 :=
    'create unique index'  ||
             '  Idx2RXN'   || 
             schemaname    || '  ' ||
            'on TabRXN'    ||
             schemaname    || '  ' ||
            '(rxnseq)';

      execute immediate sqlstmt4;
  end;
---------------------------------
  procedure  dropRxn(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    sqlstmt1 :=
    'drop table'           ||
             '  TabRXN'    || 
             schemaname;

    begin
      execute immediate sqlstmt1;
    exception
      when others then
       dbms_output.put_line('EXC: dropRxn1');
    end;

    --
    sqlstmt2 :=
    'drop sequence'       ||
             '  SeqRXN'   || 
             schemaname;

    begin
      execute immediate sqlstmt2;
    exception
      when others then
       dbms_output.put_line('EXC: dropRxn2');
    end;
  end;
---------------------------------
  procedure  createMatchTup(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    sqlstmt3  VARCHAR2(4000);
    sqlstmt4  VARCHAR2(4000);
    sqlstmt5  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;
 
    --
    sqlstmt1 :=
    'create sequence'             ||
             '  SeqRTL'      || 
             schemaname           || '  ' ||
            'START WITH 1';

    execute immediate sqlstmt1;

    --
    sqlstmt2 :=
    'create table'        ||
             '  TabRTL' || 
             schemaname      || '  ' ||
             '(mattupseq     NUMBER,                   ' ||
	     ' matindx       VARCHAR2(50)   NOT NULL,  ' ||
	     ' tokiid        VARCHAR2(50),             ' ||
	     ' tokaid        VARCHAR2(150),            ' ||
	     ' tag           VARCHAR2(250),            ' ||
	     ' vid           NUMBER,                   ' ||
	     ' vidtype       VARCHAR2(50),             ' ||
	     ' polycnd       CLOB,                     ' ||
	     ' polycndlen    NUMBER,                   ' ||
	     ' iid           VARCHAR2(50)  NOT NULL,   ' ||
	     ' aid           VARCHAR2(150),            ' ||       
	     ' rid           VARCHAR2(100),            ' ||       
	     ' recursid      NUMBER,                   ' ||       
	     ' objclassname  VARCHAR2(1000),           ' ||       
	     ' state         VARCHAR2(50),             ' ||      
	     ' type          VARCHAR2(50),             ' ||      
	     ' flags         NUMBER,                   ' ||       
	     ' rxnpri        NUMBER,                   ' ||       
	     ' timeout       NUMBER,                   ' ||       
	     ' rxnttl        VARCHAR2(30),             ' ||               
	     ' rxndate       NUMBER,                   ' ||       
	     ' tokseq        NUMBER,                   ' ||
	     ' scpiid        VARCHAR2(1000),           ' ||
	     ' scpaid        VARCHAR2(1000),           ' ||
             ' epoch         NUMBER)';

    execute immediate sqlstmt2;

    --
    sqlstmt3 :=
    'create  index'             ||
             '  Idx1RTL'   || 
             schemaname         || '  ' ||
            'on TabRTL'    ||
             schemaname         || '  ' ||
            '(iid, aid, rid, recursid, state)';

    execute immediate sqlstmt3;

    --
    sqlstmt4 :=
    'create  index'             ||
             '  Idx2RTL'   || 
             schemaname         || '  ' ||
            'on TabRTL'    ||
             schemaname         || '  ' ||
            '(tokiid, tokaid, tag)';

    execute immediate sqlstmt4;

    --
    sqlstmt5 :=
    'create unique index'       ||
             '  Idx3RTL'   || 
             schemaname         || '  ' ||
            'on TabRTL'    ||
             schemaname         || '  ' ||
            '(mattupseq)';

    execute immediate sqlstmt5;
  end;
---------------------------------
  procedure  dropMatchTup(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    sqlstmt1 :=
    'drop table'                ||
             '  TabRTL'    || 
             schemaname;

    begin
      execute immediate sqlstmt1;
    exception
      when others then
       dbms_output.put_line('EXC: dropMatchTup1');
    end;

    --
    sqlstmt2 :=
    'drop sequence'            ||
             '  SeqRTL'   || 
             schemaname;

    begin
      execute immediate sqlstmt2;
    exception
      when others then
       dbms_output.put_line('EXC: dropMatchTup2');
    end;
  end;
---------------------------------
  procedure  createToken(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    sqlstmt3  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1:=
    'create sequence'             ||
             '  SeqTOK'         || 
             schemaname           || '  ' ||
            'START WITH 1';

    execute immediate sqlstmt1;

    --
    sqlstmt2:=
    'create table'        ||
             '  TabTOK' || 
             schemaname      || '  ' ||
  	     '(tokseq        NUMBER   PRIMARY KEY,     ' ||
  	     ' prevtokseq    NUMBER,                   ' ||
  	     ' nexttokseq    NUMBER,                   ' ||
  	     ' aliastokseq   NUMBER,                   ' ||
	     ' readers       NUMBER,                   ' ||
	     ' consumer      VARCHAR2(100),            ' ||
	     ' status        VARCHAR2(50),             ' ||
	     ' iid           VARCHAR2(50)  NOT NULL,   ' ||
	     ' aid           VARCHAR2(150),            ' ||   
	     ' tag           VARCHAR2(250),            ' ||
	     ' classtag      VARCHAR2(10),             ' ||
	     ' vid           NUMBER,                   ' ||     
	     ' prevvid       NUMBER,                   ' ||     
	     ' nextvid       NUMBER,                   ' ||     
	     ' polycnd       CLOB,                     ' ||
	     ' polycndlen    NUMBER,                   ' ||
	     ' objinst       BLOB,                     ' ||
	     ' objinstlen    NUMBER,                   ' ||
	     ' textinst      CLOB,                     ' ||
	     ' textinstlen   NUMBER,                   ' ||
	     ' undoentry     BLOB,                     ' ||
	     ' undoentrylen  NUMBER,                   ' ||
	     ' state         VARCHAR2(50),             ' ||    
	     ' op            VARCHAR2(50),             ' ||    
	     ' reason        VARCHAR2(50),             ' ||    
	     ' type          VARCHAR2(50),             ' ||    
	     ' flags         NUMBER,                   ' ||     
	     ' tokttl        VARCHAR2(30),             ' ||
	     ' tokclnttl     VARCHAR2(30),             ' ||
	     ' toktime       VARCHAR2(50),             ' ||
	     ' schemausrid   VARCHAR2(50),             ' ||
             ' schemamsgid   VARCHAR2(50),             ' ||
             ' auxctx        BLOB,                     ' ||
	     ' auxctxlen     NUMBER,                   ' ||
	     ' descr         VARCHAR2(2000),           ' ||
             ' epoch         NUMBER)';

    execute immediate sqlstmt2;

    --
    sqlstmt3:=
    'create unique index'    ||
             '  Idx1TOK'   || 
             schemaname      || '  ' ||
            'on  TabTOK'   ||
             schemaname      || '  ' ||
            '(iid, aid, tag, vid)';

    execute immediate sqlstmt3;
  end;
---------------------------------
  procedure  dropToken(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    sqlstmt1 :=
    'drop table'                ||
             '  TabTOK'    || 
             schemaname;

    begin
      execute immediate sqlstmt1;
    exception
      when others then
       dbms_output.put_line('EXC: dropToken1');
    end;

    --
    sqlstmt2 :=
    'drop sequence'         ||
             '  SeqTOK'   || 
             schemaname;

    begin
      execute immediate sqlstmt2;
    exception
      when others then
       dbms_output.put_line('EXC: dropToken2');
    end;
  end;
---------------------------------
  procedure  createTrk(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);	 
    sqlstmt2  VARCHAR2(4000);	 
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    sqlstmt1 :=
    'create sequence'             ||
             '  SeqTRK'           || 
             schemaname           || '  ' ||
            'START WITH 1';

    execute immediate sqlstmt1;

    --
    sqlstmt2 :=
    'create table'        ||
             '  TabTRK'   || 
             schemaname   || '  ' ||
  	     '(trkseq        NUMBER   PRIMARY KEY,   ' ||
	     ' tokseq        NUMBER,          ' ||
	     ' instid        VARCHAR2(100),   ' ||
	     ' iid           VARCHAR2(50),    ' ||
	     ' aid           VARCHAR2(150),   ' ||
	     ' handle           VARCHAR2(2000),  ' ||
	     ' rid           VARCHAR2(100),   ' ||
	     ' recursid      NUMBER,	      ' ||
	     ' op            VARCHAR2(50),    ' ||
	     ' reason        VARCHAR2(50),    ' ||
	     ' toiid         VARCHAR2(50),    ' ||
	     ' toaid         VARCHAR2(150),   ' ||
	     ' tohandle         VARCHAR2(100),   ' ||
	     ' toprspeid     VARCHAR2(100),   ' ||
	     ' torxnpeid     VARCHAR2(100),   ' ||
	     ' description   VARCHAR2(2000),  ' ||
	     ' trkdate       VARCHAR2(30),    ' ||
  	     ' schemausrid   VARCHAR2(50),    ' ||
             ' schemamsgid   VARCHAR2(50),    ' ||
	     ' direction     VARCHAR2(50),    ' ||
             ' epoch         NUMBER)';

    execute immediate sqlstmt2;
  end;
---------------------------------
  procedure  dropTrk(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    sqlstmt1 :=
    'drop table'                ||
             '  TabTRK'    || 
             schemaname;

    begin
      execute immediate sqlstmt1;
    exception
      when others then
       dbms_output.put_line('EXC: dropTrk1');
    end;

    --
    sqlstmt2 :=
    'drop sequence'       ||
             '  SeqTRK'   || 
             schemaname;

    begin
      execute immediate sqlstmt2;
    exception
      when others then
       dbms_output.put_line('EXC: dropTrk2');
    end;
  end;
---------------------------------
  procedure  createPrv(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    sqlstmt3  VARCHAR2(4000);
    sqlstmt4  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'create sequence'        ||
             '  SeqPRV'      || 
             schemaname      || '  ' ||
            'START WITH 1';

    execute immediate sqlstmt1;

    --
    sqlstmt2 :=
    'create table'        ||
             '  TabPRV'   || 
             schemaname   || '  ' || 
	   '(schemausrid      VARCHAR2(50)  NOT NULL,   ' ||
	   ' ctrid            VARCHAR2(50)  NOT NULL,   ' || 
	   ' roleid           VARCHAR2(50)  NOT NULL,   ' || 
           ' description      VARCHAR2(2000),           ' ||
	   ' grdate           VARCHAR2(30)             )';

    execute immediate sqlstmt2;

    --
    sqlstmt3 :=
    'create unique index'  ||
             '  Idx1PRV'   || 
             schemaname    || '  ' ||
            'on TabPRV'    ||
             schemaname    || '  ' ||
            '(schemausrid, ctrid)';

      execute immediate sqlstmt3;

  end;
---------------------------------
  procedure  dropPrv(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    sqlstmt1 :=
    'drop table'           ||
             '  TabPRV'    || 
             schemaname;

    begin
      execute immediate sqlstmt1;
    exception
      when others then
       dbms_output.put_line('EXC: dropPRV1');
    end;

    --
    sqlstmt2 :=
    'drop sequence'       ||
             '  SeqPRV'   || 
             schemaname;

    begin
      execute immediate sqlstmt2;
    exception
      when others then
       dbms_output.put_line('EXC: dropPRV2');
    end;
  end;
---------------------------------
  procedure  initTabs(
                instid                      IN VARCHAR2, 
                dbusname                    IN VARCHAR2,
                description                 IN VARCHAR2  DEFAULT NULL,
                max_retries                 IN NUMBER    DEFAULT 1,
                retry_delay                 IN NUMBER    DEFAULT 0,
                gccycle                     IN NUMBER    DEFAULT 10000)  is
    sqlstmt1  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
    version VARCHAR2(20) := '1.0';
    sysiid  VARCHAR2(20) := 'JEM$SYSIID';
    sysaid  VARCHAR2(20) := 'JEM$SYSAID';
    glbiid  VARCHAR2(20) := 'JEM$GLBIID';
    glbaid  VARCHAR2(20) := 'JEM$GLBAID';
    ixnaid  VARCHAR2(20) := 'JEM$IXNAID';
    state   VARCHAR2(20) := 'DFBST_INIT';
    dateformat  VARCHAR2(20) := 'DD-MON-YYYY:HH:MI:SS';

  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    sqlstmt1 :=
    'insert into          ' ||
    '             TabDFB' ||
              schemaname    || ' ' ||
    '	      (instid     ,      ' ||		     
    '	       version    ,      ' ||		     
    '	       scn        ,      ' ||		     
    '	       sysiid     ,      ' ||		     
    '	       sysaid     ,      ' ||		     
    '	       glbiid     ,      ' ||		     
    '	       glbaid     ,      ' ||		     
    '	       ixnaid     ,      ' ||		     
    '	       maxrxnretry,      ' ||		     
    '	       state      ,      ' ||		     
    '	       creatdate  ,	 ' ||
    '	       tokttldiff ,	 ' ||
    '	       tokttlcalldiff,	 ' ||
    '	       tokttldatdiff,	 ' ||
    '	       tokclnttldiff ,	 ' ||
    '	       rxnttldiff,	 ' ||
    '	       gccycle,          ' ||
    '	       epoch, epochnext) ' ||
    '	       values      ' ||                       
    '  	      (:dat1, ' ||
    '	       :dat2, ' ||
    '	       0,     ' ||
    '	       :dat3, ' ||
    '	       :dat4, ' ||
    '	       :dat5, ' ||
    '	       :dat6, ' ||
    '	       :dat7, ' ||
    '	       2,     ' ||
    '	       :dat8, ' ||
    '	       TO_CHAR(SYSDATE, ' || ':dat9' || '), ' ||
    '	       null,   ' ||
    '	       null,   ' ||
    '	       null,   ' ||
    '	       null,   ' ||
    '	       null,   ' ||
    '	       :dat10, ' ||
    '	       1,      ' ||
    '          1)';

    execute immediate sqlstmt1
       using
    	      instid,
              version,
              sysiid,
              sysaid,
              glbiid,
              glbaid,
              ixnaid,
	      state,
              dateformat,
	      gccycle;

   -- 
   commit;
 end;
---------------------------------
  procedure  addRole(
                dbusname                    IN VARCHAR2  DEFAULT NULL,
                schemausrid                 IN VARCHAR2,
                ctrid                       IN VARCHAR2,
                roleid                      IN VARCHAR2,
                description                 IN VARCHAR2  DEFAULT NULL) is
    sqlstmt1    VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
    dateformat  VARCHAR2(20) := 'DD-MON-YYYY:HH:MI:SS';
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    sqlstmt1 :=
    'insert into          ' ||
    '             TabPRV' ||
              schemaname  || ' ' ||
    '	      (schemausrid, ' ||
    '	       ctrid,       ' ||
    '	       roleid,      ' ||
    '	       description, ' ||
    '          grdate)      ' ||
    '	       values       ' ||                       
    '  	      (:dat1, ' ||
    '	       :dat2, ' ||
    '	       :dat3, ' ||
    '	       :dat4, ' ||
    '	       TO_CHAR(SYSDATE, ' || ':dat5' || ')';

    declare
      err_num  NUMBER;
      err_msg  VARCHAR2(100);
    begin
      execute immediate sqlstmt1
         using
	      schemausrid,
    	      ctrid,
    	      roleid,
	      description,
	      dateformat;
    exception
      when DUP_VAL_ON_INDEX then
       err_num := SQLCODE;
       err_msg := SQLERRM;

       dbms_output.put_line(err_msg);

       raise_application_error(-20002, 
                               err_msg);
      when others then
       err_num := SQLCODE;
       err_msg := SQLERRM;

       dbms_output.put_line(err_msg);

       raise_application_error(-20100, 
                               err_msg);
    end;

   -- 
   commit;
 end;
---------------------------------
  procedure  removeRole(
                dbusname                    IN VARCHAR2  DEFAULT NULL,
                schemausrid                 IN VARCHAR2,
                ctrid                       IN VARCHAR2 DEFAULT NULL,
                roleid                      IN VARCHAR2 DEFAULT NULL) is
    sqlstmt1  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    if (ctrid is null) then
      sqlstmt1 :=
      'delete from        ' ||
      '             TabPRV' ||
                schemaname  || ' ' ||
      '  where schemausrid = :dat1 ';

      execute immediate sqlstmt1
         using
	      schemausrid;
    elsif (roleid is null) then
      sqlstmt1 :=
      'delete from        ' ||
      '             TabPRV' ||
                schemaname  || ' ' ||
      '  where schemausrid = :dat1  AND  ' ||
      '        ctrid       = :dat2 ';

      execute immediate sqlstmt1
         using
	      schemausrid,
    	      ctrid;
    else
      sqlstmt1 :=
      'delete from        ' ||
      '             TabPRV' ||
                schemaname  || ' ' ||
      '  where schemausrid = :dat1  AND  ' ||
      '        ctrid       = :dat2  AND  ' ||
      '        roleid      = :dat3       ';
    end if;


    declare
      err_num  NUMBER;
      err_msg  VARCHAR2(100);
    begin
      execute immediate sqlstmt1
         using
	      schemausrid,
    	      ctrid,
    	      roleid;
    exception
      when others then
       err_num := SQLCODE;
       err_msg := SQLERRM;

       dbms_output.put_line(err_msg);

       raise_application_error(-20100, 
                               err_msg);
    end;

   -- 
   commit;
 end;
---------------------------------
  procedure  grantTabs(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    sqlstmt3  VARCHAR2(1000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'grant select on '       ||
             '  TabDFB'      || 
             schemaname      || '  ' ||
             'to JEMrole';
    execute immediate sqlstmt1;
  end;
---------------------------------
  procedure  createTabSynonyms(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'create public synonym  '  ||
             '  TabDFB'        || 
             schemaname        || '  ' ||
             'for '            ||
             '  TabDFB'        || 
             schemaname;
    execute immediate sqlstmt1;

    --
    sqlstmt2 :=
    'create public synonym  '  ||
             '  TabNTF'        || 
             schemaname        || '  ' ||
             'for '            ||
             '  TabNTF'        || 
             schemaname;
    execute immediate sqlstmt2;
  end;
---------------------------------
  procedure  dropTabSynonyms(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'drop   public synonym  '  ||
             '  TabDFB'        || 
             schemaname;
    begin
      execute immediate sqlstmt1;
    exception
      when others then
       dbms_output.put_line('EXC: dropTabSynonyms');
    end;

    --
    sqlstmt2 :=
    'drop   public synonym  '  ||
             '  TabNTF'        || 
             schemaname;
    begin
      execute immediate sqlstmt2;
    exception
      when others then
       dbms_output.put_line('EXC: dropTabSynonyms');
    end;

  end;
---------------------------------
  procedure  createVwNtfRegistration(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    sqlstmt3  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'create or replace view  '        ||
             '  NTF'      || 
             schemaname               || '  ' ||
    'as  select   ' ||
    '	       tschema            NtfSchema,               ' ||
    '	       tname              NtfQueTableName,	   ' ||
    '	       name               NtfDestName,		   ' ||
    '	       excname            NtfExcQueName,	   ' ||
    '	       payloadtype        NtfPayloadType,	   ' ||
    '	       type               NtfType,		   ' ||
    '	       dir                NtfDir,		   ' ||
    '	       tconsname          NtfConsumerName,	   ' ||
    '	       msgselector        NtfMsgSelector,	   ' ||
    '	       userId             NtfUserId,		   ' ||
    '	       objname            NtfObjectName,	   ' ||
    '	       implid             NtfBeanClassName,	   ' ||
    '	       homintfname        NtfHomeInterfaceName,	   ' ||
    '	       remintfname        NtfRemoteInterfaceName   ' ||
    'from  TabNTF' ||
    schemaname;

    execute immediate sqlstmt1;

    --
    sqlstmt2 :=
    'grant select  on '                 ||
             '  NTF'         ||
             schemaname      || '  '    ||
             'to JEMrole';

    --execute immediate sqlstmt2;

    --
    sqlstmt3 :=
    'create public synonym  '  ||
             '  NTF'           || 
             schemaname        || '  ' ||
             'for '            ||
             '  NTF'           || 
             schemaname;
    execute immediate sqlstmt3;
  end;
---------------------------------
  procedure  dropVwNtfRegistration(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'drop view  '        ||
             '  NTF'      || 
             schemaname;

    begin
      execute immediate sqlstmt1;
    exception
      when others then
       dbms_output.put_line('EXC: dropVwNtfRegistration');
    end;

    --
    sqlstmt2 :=
    'drop   public synonym  '  ||
             '  NTF'           || 
             schemaname;
    begin
      execute immediate sqlstmt2;
    exception
      when others then
       dbms_output.put_line('EXC: dropVwNtfRegistration');
    end;
  end;
---------------------------------
  procedure  createVwProcess(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    sqlstmt3  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'create or replace view  '        ||
             '  PRS'              || 
             schemaname               || '  ' ||
    'as  select   ' ||
    '	       iid            ,  ' ||
    '	       aid            ,	 ' ||
    '	       retiid         ,  ' ||
    '	       retaid         ,  ' ||
    '	       rethandlelen      ,	 ' ||
    '	       prspeid        ,	 ' ||
    '	       cmpltag        ,	 ' ||
    '	       state          ,	 ' ||
    '	       flags          ,  ' ||		      
    '	       prsstart       ,  ' ||
    '	       prsend            ' ||
    'from  TabPRS' ||
    schemaname;

    execute immediate sqlstmt1;

    --
    sqlstmt2 :=
    'grant select  on '      ||
             '  PRS'     ||
             schemaname      || '  '    ||
             'to JEMrole';

    --execute immediate sqlstmt2;

    --
    sqlstmt3 :=
    'create public synonym  '  ||
             '  PRS'           || 
             schemaname        || '  ' ||
             'for '            ||
             '  PRS'           || 
             schemaname;
    execute immediate sqlstmt3;
  end;
---------------------------------
  procedure  dropVwProcess(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'drop view  '             ||
             '  PRS'      || 
             schemaname;

    begin
      execute immediate sqlstmt1;
    exception
      when others then 
       dbms_output.put_line('EXC: dropVwProcess');
    end;

    --
    sqlstmt2 :=
    'drop   public synonym  '  ||
             '  PRS'           || 
             schemaname;
    begin
      execute immediate sqlstmt2;
    exception
      when others then 
       dbms_output.put_line('EXC: dropVwProcess');
    end;
  end;
---------------------------------
  procedure  createVwReaction(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    sqlstmt3  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'create or replace view  '        ||
             '  RXN'                  || 
             schemaname               || '  ' ||
    'as  select  ' ||
    '	     iid              ,   ' ||
    '	     aid              ,   ' ||		
    '	     rid              ,   ' ||		
    '	     recursid         ,	  ' ||
    '	     prspeid          ,   ' ||		
    '	     rxnpeid          ,   ' ||		
    '	     grpid            ,   ' ||
    '	     totmattups       ,   ' ||
    '	     retrycnt         ,   ' ||		       
    '	     state            ,   ' ||		
    '	     status           ,   ' ||		
    '	     type             ,   ' ||		
    '	     flags            ,   ' ||		       
    '	     rxnpri           ,   ' ||		       
    '	     rxnttl           ,	  ' ||
    '	     descr  description ,	  ' ||
    '	     rxndate          ,   ' ||		       
    '	     rxnstart         ,   ' ||			 
    '	     rxnend               ' ||
    'from  TabRXN'  ||
    schemaname      ||
    '  order by  rxndate  asc';

    execute immediate sqlstmt1;

    --
    sqlstmt2 :=
    'grant select  on '      ||
             '  RXN'         ||
             schemaname      || '  '    ||
             'to JEMrole';

    --execute immediate sqlstmt2;

    --
    sqlstmt3 :=
    'create public synonym  '  ||
             '  RXN'           || 
             schemaname        || '  ' ||
             'for '            ||
             '  RXN'           || 
             schemaname;
    execute immediate sqlstmt3;
  end;
---------------------------------
  procedure  dropVwReaction(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'drop view  '              ||
             '  RXN'           || 
             schemaname;

    begin
      execute immediate sqlstmt1;
    exception
      when others then
       dbms_output.put_line('EXC: dropVwReaction');
    end;

    --
    sqlstmt2 :=
    'drop   public synonym  '  ||
             '  RXN'           || 
             schemaname;
    begin
      execute immediate sqlstmt2;
    exception
      when others then 
       dbms_output.put_line('EXC: dropVwReaction');
    end;
  end;
---------------------------------
  procedure  createVwReactionTemplate(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    sqlstmt3  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'create or replace view  '         ||
             '  RTL'      || 
             schemaname                || '  ' ||
    'as  select  ' ||
    '	       mattupseq     ,  ' ||
    '	       matindx       ,  ' ||
    '	       tokiid        ,  ' ||	     
    '	       tokaid        ,	' ||
    '	       tag           ,	' ||
    '	       vid           ,  ' ||		    
    '	       vidtype       ,  ' ||	      
    '	       iid           ,  ' ||
    '	       aid           ,  ' ||	     
    '	       rid           ,  ' ||	     
    '	       recursid      ,  ' ||		    
    '          polycnd       ,  ' ||
    '	       objclassname  ,  ' ||	     
    '	       state         ,  ' ||	     
    '	       type          ,  ' ||	     
    '	       flags         ,  ' ||		    
    '	       rxnpri        ,  ' ||		    
    '	       timeout       ,  ' ||
    '	       tokseq        ,	' ||
    '	       scpiid        ,	' ||
    '	       scpaid           ' ||
    'from  TabRTL' ||
    schemaname;

    execute immediate sqlstmt1;

    --
    sqlstmt2 :=
    'grant select  on '              ||
             '  RTL'                 ||
             schemaname              || '  '    ||
             'to JEMrole';

    --execute immediate sqlstmt2;

    --
    sqlstmt3 :=
    'create public synonym  '  ||
             '  RTL'           || 
             schemaname        || '  ' ||
             'for '            ||
             '  RTL'           || 
             schemaname;
    execute immediate sqlstmt3;
  end;
---------------------------------
  procedure  dropVwReactionTemplate(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'drop view  '         ||
             '  RTL'      || 
             schemaname;

    begin
      execute immediate sqlstmt1;
    exception
      when others then
       dbms_output.put_line('EXC: dropVwReactionTemplate');
    end;

    --
    sqlstmt2 :=
    'drop   public synonym  '  ||
             '  RTL'           || 
             schemaname;
    begin
      execute immediate sqlstmt2;
    exception
      when others then 
       dbms_output.put_line('EXC: dropVwReactionTemplate');
    end;
  end;
---------------------------------
  procedure  createVwActiveData(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    sqlstmt3  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'create or replace view  '        ||
             '  TOK'           || 
             schemaname               || '  ' ||
    ' as select  ' ||
    '	       tokseq        ,    ' ||
    '	       prevtokseq    ,    ' ||		   
    '	       nexttokseq    ,    ' ||		   
    '	       aliastokseq   ,    ' ||
    '	       readers       ,    ' ||		   
    '	       consumer      ,    ' ||	    
    '	       status        ,    ' ||	    
    '	       iid           , 	  ' ||
    '	       aid           ,    ' ||	    
    '	       tag           ,	  ' ||
    '	       vid           ,    ' ||		   
    '	       prevvid       ,    ' ||		   
    '	       nextvid       ,	  ' ||
    '          polycnd       ,    ' ||
    '	       textinst      ,    ' ||	    
    '	       textinstlen   ,    ' ||	    
    '	       state         ,    ' ||	    
    '	       op            ,    ' ||	    
    '	       reason        ,    ' ||	    
    '	       type          ,    ' ||	    
    '	       flags         ,    ' ||		   
    '	       tokttl        ,    ' ||
    '	       tokclnttl     ,    ' ||
    '	       toktime            ' ||
    'from  TabTOK' ||
    schemaname;

    execute immediate sqlstmt1;

    --
    sqlstmt2 :=
    'grant select  on '              ||
             '  TOK'                 ||
             schemaname              || '  '    ||
             'to JEMrole';

    --execute immediate sqlstmt2;

    --
    sqlstmt3 :=
    'create public synonym  '  ||
             '  TOK'           || 
             schemaname        || '  ' ||
             'for '            ||
             '  TOK'           || 
             schemaname;
    execute immediate sqlstmt3;
  end;
---------------------------------
  procedure  dropVwActiveData(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'drop view  '            ||
             '  TOK'         || 
             schemaname;

    begin
      execute immediate sqlstmt1;
    exception
      when others then
       dbms_output.put_line('EXC: dropVwActiveData');
    end;

    --
    sqlstmt2 :=
    'drop   public synonym  '  ||
             '  TOK'           || 
             schemaname;
    begin
      execute immediate sqlstmt2;
    exception
      when others then 
       dbms_output.put_line('EXC: dropVwActiveData');
    end;
  end;
---------------------------------
  procedure  createVwTracking(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    sqlstmt3  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
    jemusername  VARCHAR2(10) := '''JEMUSER''';
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'create or replace view  '        ||
             '  TRK'                  || 
             schemaname               || '  ' ||
    'as select  ' ||
    '	       tok.tokseq        ,   ' ||
    '	       tok.prevtokseq    ,   ' ||	       
    '	       tok.nexttokseq    ,   ' ||	       
    '	       tok.aliastokseq   ,   ' ||	       
    '	       tok.readers       ,   ' ||	       
    '	       tok.consumer      ,   ' ||	
    '	       tok.status        ,   ' ||	
    '	       tok.iid   tokiid  ,   ' ||
    '	       tok.aid   tokaid  ,   ' ||	
    '	       tok.tag           ,   ' ||
    '	       tok.vid           ,   ' ||	       
    '	       tok.prevvid       ,   ' ||	       
    '	       tok.nextvid       ,   ' ||
    '          tok.polycnd       ,   ' ||
    '	       tok.state         ,   ' ||	
    '	       tok.type          ,   ' ||	
    '	       tok.flags         ,   ' ||	       
    '	       tok.tokttl        ,   ' ||
    '	       tok.tokclnttl     ,   ' ||
    '	       tok.toktime       ,   ' ||
    '	       trk.instid        ,   ' ||    
    '	       trk.iid   trkiid  ,   ' ||	
    '	       trk.aid   trkaid  ,   ' ||	
    '	       trk.rid           ,   ' ||	
    '	       trk.recursid      ,   ' ||
    '	       trk.op            ,   ' ||	 
    '	       trk.reason        ,   ' ||    
    '	       trk.toiid         ,   ' ||
    '	       trk.toaid         ,   ' ||
    '	       trk.tohandle      ,   ' ||
    '	       trk.toprspeid     ,   ' ||
    '	       trk.torxnpeid     ,   ' ||
    '	       trk.description   ,   ' ||
    '	       trk.direction     ,   ' ||
    '	       trk.trkdate           ' ||
    'from  TabTRK'   ||
    schemaname       || '  trk,' ||
    '      TabTOK' ||
    schemaname       || '  tok'  ||
    '  where trk.tokseq = tok.tokseq  AND  ' ||

    '         (' ||
    '          (trk.schemausrid = (select UPPER(user) from dual)))';

    execute immediate sqlstmt1;

    --
    sqlstmt2 :=
    'grant select  on '         ||
             '  TRK'            ||
             schemaname         || '  '    ||
             'to JEMrole';

    execute immediate sqlstmt2;

    --
    sqlstmt3 :=
    'create public synonym  '  ||
             '  TRK'           || 
             schemaname        || '  ' ||
             'for '            ||
             '  TRK'           || 
             schemaname;
    execute immediate sqlstmt3;
  end;
---------------------------------
  procedure  dropVwTracking(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'drop view  '            ||
             '  TRK'         || 
             schemaname;

    begin
      execute immediate sqlstmt1;
    exception
      when others then
       dbms_output.put_line('EXC: dropVwTracking');
    end;

    --
    sqlstmt2 :=
    'drop   public synonym  '  ||
             '  TRK'           || 
             schemaname;
    begin
      execute immediate sqlstmt2;
    exception
      when others then 
       dbms_output.put_line('EXC: dropVwActiveData');
    end;
  end;
---------------------------------
  procedure  createVwDatabus(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    sqlstmt3  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'create or replace view  '        ||
             '  DFB'              || 
             schemaname               || '  ' ||
    'as select  ' ||
    '	       instid,                          ' ||
    '	       version, 			' ||
    '	       maxrxnretry "MaxReactionRetry",  ' ||
    '	       state,    			' ||
    '	       creatdate,			' ||
    '	       tokttldiff,			' ||
    '	       tokttlcalldiff,			' ||
    '	       tokttldatdiff,			' ||
    '	       tokclnttldiff,			' ||
    '	       rxnttldiff,			' ||
    '	       gccycle                          ' ||
    'from  TabDFB' ||
    schemaname;

    execute immediate sqlstmt1;

    --
    sqlstmt2 :=
    'grant select  on '              ||
             '  DFB'                 ||
             schemaname              || '  '    ||
             'to JEMrole';

    execute immediate sqlstmt2;

    --
    sqlstmt3 :=
    'create public synonym  '  ||
             '  DFB'           || 
             schemaname        || '  ' ||
             'for '            ||
             '  DFB'           || 
             schemaname;
    execute immediate sqlstmt3;
  end;
---------------------------------
  procedure  dropVwDatabus(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt1 :=
    'drop view  '                ||
             '  DFB'             || 
             schemaname;

    begin
      execute immediate sqlstmt1;
    exception
      when others then
       dbms_output.put_line('EXC: dropVwDatabus');
    end;

    --
    sqlstmt2 :=
    'drop   public synonym  '  ||
             '  DFB'           || 
             schemaname;
    begin
      execute immediate sqlstmt2;
    exception
      when others then 
       dbms_output.put_line('EXC: dropVwDatabus');
    end;
  end;
---------------------------------
---------------------------------
  procedure  createQues(
                dbusname                    IN     VARCHAR2,
                max_retries                 IN     NUMBER    DEFAULT 1,
                retry_delay                 IN     NUMBER    DEFAULT 0,
                retention_time              IN     NUMBER    DEFAULT 0)  is
    quetablename    VARCHAR2(100);
    matchquename    VARCHAR2(100);
    schedquename    VARCHAR2(100);
    directquename   VARCHAR2(100);
    foreignquename  VARCHAR2(100);
    excquename      VARCHAR2(100);
    instid          VARCHAR2(100);
    maxrxnretry     NUMBER;
  begin
    quetablename   := 'JEMUSER.QT' || dbusname;
    matchquename   := 'JEMUSER.MQ'  || dbusname;
    schedquename   := 'JEMUSER.SQ'  || dbusname;
    directquename  := 'JEMUSER.DQ'  || dbusname;
    foreignquename := 'JEMUSER.FQ'  || dbusname;
    excquename     := 'JEMUSER.AQ$_QT' || dbusname || '_E';

    --
    DBMS_AQADM.CREATE_QUEUE_TABLE(
      Queue_table            => quetablename,
      Queue_payload_type     => 'SYS.AQ$_JMS_BYTES_MESSAGE',
      compatible             => '8.1.5');
  
    --
    DBMS_AQADM.CREATE_QUEUE( 
      Queue_name          => matchquename, 
      Queue_table         => quetablename,
      max_retries         => max_retries,                 
      retry_delay         => retry_delay,                 
      retention_time      => retention_time);

    --
    DBMS_AQADM.CREATE_QUEUE( 
      Queue_name          => schedquename, 
      Queue_table         => quetablename,
      max_retries         => max_retries,                 
      retry_delay         => retry_delay,                 
      retention_time      => retention_time);

    --
    DBMS_AQADM.CREATE_QUEUE( 
      Queue_name          => directquename, 
      Queue_table         => quetablename,
      max_retries         => max_retries,                 
      retry_delay         => retry_delay,                 
      retention_time      => retention_time);

    --
    DBMS_AQADM.CREATE_QUEUE( 
      Queue_name          => foreignquename, 
      Queue_table         => quetablename,
      max_retries         => max_retries,                 
      retry_delay         => retry_delay,                 
      retention_time      => retention_time);

    --
    DBMS_AQADM.START_QUEUE(
      queue_name         => matchquename);

    --
    DBMS_AQADM.START_QUEUE(
      queue_name         => schedquename);

    --
    DBMS_AQADM.START_QUEUE(
      queue_name         => directquename);

    --
    DBMS_AQADM.START_QUEUE(
      queue_name         => foreignquename);

    --
    DBMS_AQADM.START_QUEUE( 
      queue_name         => excquename,
      dequeue            => TRUE, 
      enqueue            => FALSE); 

    --
    /* TODO: this is the correct
    DBMS_AQADM.GRANT_QUEUE_PRIVILEGE( 
      'ENQUEUE', matchquename, 'JEMrole', FALSE); 

    --
    DBMS_AQADM.GRANT_QUEUE_PRIVILEGE( 
      'ENQUEUE', schedquename, 'JEMrole', FALSE); 

    --
    DBMS_AQADM.GRANT_QUEUE_PRIVILEGE( 
      'ENQUEUE', directquename, 'JEMrole', FALSE); 

    --
    DBMS_AQADM.GRANT_QUEUE_PRIVILEGE( 
      'ENQUEUE', foreignquename, 'JEMrole', FALSE); 
    */

    --
    DBMS_AQADM.GRANT_QUEUE_PRIVILEGE( 
      'ALL', matchquename, 'JEMrole', FALSE); 

    --
    DBMS_AQADM.GRANT_QUEUE_PRIVILEGE( 
      'ALL', schedquename, 'JEMrole', FALSE); 

    --
    DBMS_AQADM.GRANT_QUEUE_PRIVILEGE( 
      'ALL', directquename, 'JEMrole', FALSE); 

    --
    DBMS_AQADM.GRANT_QUEUE_PRIVILEGE( 
      'ALL', foreignquename, 'JEMrole', FALSE); 
 end;
---------------------------------
  procedure  createTpcs(
                dbusname                    IN     VARCHAR2,
                max_retries                 IN     NUMBER    DEFAULT 1,
                retry_delay                 IN     NUMBER    DEFAULT 0,
                retention_time              IN     NUMBER    DEFAULT 0)  is
    quetablename    VARCHAR2(100);
    matchquename    VARCHAR2(100);
    schedquename    VARCHAR2(100);
    directquename   VARCHAR2(100);
    foreignquename  VARCHAR2(100);
    excquename      VARCHAR2(100);
    instid          VARCHAR2(100);
    maxrxnretry     NUMBER;
    subscriber   sys.aq$_agent; 
  begin
    quetablename   := 'JEMUSER.QT' || dbusname;
    matchquename   := 'JEMUSER.MQ'    || dbusname;
    schedquename   := 'JEMUSER.SQ'    || dbusname;
    directquename  := 'JEMUSER.DQ'    || dbusname;
    foreignquename := 'JEMUSER.FQ'    || dbusname;
    excquename     := 'JEMUSER.AQ$_QT' || dbusname || '_E';

    --
    DBMS_AQADM.CREATE_QUEUE_TABLE(
      Queue_table            => quetablename,
      Multiple_consumers     => TRUE, 
      Queue_payload_type     => 'SYS.AQ$_JMS_BYTES_MESSAGE',
      compatible             => '8.1.5');
  
    --
    DBMS_AQADM.CREATE_QUEUE( 
      Queue_name          => matchquename, 
      Queue_table         => quetablename,
      max_retries         => max_retries,                 
      retry_delay         => retry_delay,                 
      retention_time      => retention_time);

    subscriber :=  
      sys.aq$_agent('JEMSUB' || dbusname, null, null); 

    DBMS_AQADM.ADD_SUBSCRIBER(
      queue_name           => matchquename, 
      subscriber           => subscriber);

    --
    DBMS_AQADM.CREATE_QUEUE( 
      Queue_name          => schedquename, 
      Queue_table         => quetablename,
      max_retries         => max_retries,                 
      retry_delay         => retry_delay,                 
      retention_time      => retention_time);

    subscriber :=  
      sys.aq$_agent('JEMSUB' || dbusname, null, null); 

    DBMS_AQADM.ADD_SUBSCRIBER(
      queue_name           => schedquename, 
      subscriber           => subscriber);

    --
    DBMS_AQADM.CREATE_QUEUE( 
      Queue_name          => directquename, 
      Queue_table         => quetablename,
      max_retries         => max_retries,                 
      retry_delay         => retry_delay,                 
      retention_time      => retention_time);

    subscriber :=  
      sys.aq$_agent('JEMSUB' || dbusname, null, null); 

    DBMS_AQADM.ADD_SUBSCRIBER(
      queue_name           => directquename, 
      subscriber           => subscriber);

    --
    DBMS_AQADM.CREATE_QUEUE( 
      Queue_name          => foreignquename, 
      Queue_table         => quetablename,
      max_retries         => max_retries,                 
      retry_delay         => retry_delay,                 
      retention_time      => retention_time);

    subscriber :=  
      sys.aq$_agent('JEMSUB' || dbusname, null, null); 

    DBMS_AQADM.ADD_SUBSCRIBER(
      queue_name           => foreignquename, 
      subscriber           => subscriber);

    --
    DBMS_AQADM.START_QUEUE(
      queue_name         => matchquename);

    --
    DBMS_AQADM.START_QUEUE(
      queue_name         => schedquename);

    --
    DBMS_AQADM.START_QUEUE(
      queue_name         => directquename);

    --
    DBMS_AQADM.START_QUEUE(
      queue_name         => foreignquename);

    --
    DBMS_AQADM.START_QUEUE( 
      queue_name         => excquename,
      dequeue            => TRUE, 
      enqueue            => FALSE); 

    --
    /*
    DBMS_AQADM.GRANT_QUEUE_PRIVILEGE( 
      'ENQUEUE', matchquename, 'JEMrole', FALSE); 

    --
    DBMS_AQADM.GRANT_QUEUE_PRIVILEGE( 
      'ENQUEUE', schedquename, 'JEMrole', FALSE); 

    --
    DBMS_AQADM.GRANT_QUEUE_PRIVILEGE( 
      'ENQUEUE', directquename, 'JEMrole', FALSE); 

    --
    DBMS_AQADM.GRANT_QUEUE_PRIVILEGE( 
      'ENQUEUE', foreignquename, 'JEMrole', FALSE); 
    */

    --
    DBMS_AQADM.GRANT_QUEUE_PRIVILEGE( 
      'ALL', matchquename, 'JEMrole', FALSE); 

    --
    DBMS_AQADM.GRANT_QUEUE_PRIVILEGE( 
      'ALL', schedquename, 'JEMrole', FALSE); 

    --
    DBMS_AQADM.GRANT_QUEUE_PRIVILEGE( 
      'ALL', directquename, 'JEMrole', FALSE); 

    --
    DBMS_AQADM.GRANT_QUEUE_PRIVILEGE( 
      'ALL', foreignquename, 'JEMrole', FALSE); 
 end;

---------------------------------
  procedure  createAppGroupSubscriber(
                dbusname   IN     VARCHAR2,
                subname    IN     VARCHAR2 DEFAULT  'JEMSUB')  is
    quetablename    VARCHAR2(100);
    matchquename    VARCHAR2(100);
    schedquename    VARCHAR2(100);
    directquename   VARCHAR2(100);
    foreignquename  VARCHAR2(100);
    excquename      VARCHAR2(100);
    subscriber   sys.aq$_agent; 
  begin
    quetablename   := 'JEMUSER.QT' || dbusname;
    matchquename   := 'JEMUSER.MQ'    || dbusname;
    schedquename   := 'JEMUSER.SQ'    || dbusname;
    directquename  := 'JEMUSER.DQ'   || dbusname;
    foreignquename := 'JEMUSER.FQ'  || dbusname;
    excquename     := 'JEMUSER.AQ$_QT' || dbusname || '_E';

    --
    subscriber :=  
      sys.aq$_agent(subname || dbusname, null, null); 

    DBMS_AQADM.ADD_SUBSCRIBER(
      queue_name           => matchquename, 
      subscriber           => subscriber);

    --
    subscriber :=  
      sys.aq$_agent(subname || dbusname, null, null); 

    DBMS_AQADM.ADD_SUBSCRIBER(
      queue_name           => schedquename, 
      subscriber           => subscriber);

    --
    subscriber :=  
      sys.aq$_agent(subname || dbusname, null, null); 

    DBMS_AQADM.ADD_SUBSCRIBER(
      queue_name           => directquename, 
      subscriber           => subscriber);

    --
    subscriber :=  
      sys.aq$_agent(subname || dbusname, null, null); 

    DBMS_AQADM.ADD_SUBSCRIBER(
      queue_name           => foreignquename, 
      subscriber           => subscriber);
 end;
---------------------------------
  procedure  dropAppGroupSubscriber(
                dbusname  IN     VARCHAR2,
                subname   IN     VARCHAR2 DEFAULT  'JEMSUB')  is
  begin
    dropSubMatchQue(dbusname, subname);
    dropSubSchedQue(dbusname, subname);
    dropSubDirectQue(dbusname, subname);
    dropSubForeignQue(dbusname, subname);
  end;
---------------------------------
--TODO: remove these
  procedure  grantQues(dbusname  IN VARCHAR2) is
    sqlstmt1  VARCHAR2(4000);
    sqlstmt2  VARCHAR2(4000);
    schemaname  VARCHAR2(100) := dbusname;
  begin
    if schemaname is null then
      schemaname := '';  
    end if;

    --
    sqlstmt2 :=
    'grant select, insert, update on '     ||
             '  AQ$QT'                     || 
             schemaname      || '  '       ||
             'to JEMCLIUSER';
    --execute immediate sqlstmt2;

  end;
---------------------------------
  procedure  stopMatchQue(dbusname  IN VARCHAR2)  is
    matchquename    VARCHAR2(100);
  begin
    matchquename   := 'JEMUSER.MQ'    || dbusname;

    DBMS_AQADM.STOP_QUEUE(
        queue_name         => matchquename);
  exception
    when others then
       dbms_output.put_line('EXC: stopMatchQue');
    return;
  end;
---------------------------------
  procedure  stopSchedQue(dbusname  IN VARCHAR2)  is
    schedquename    VARCHAR2(100);
  begin
    schedquename   := 'JEMUSER.SQ'    || dbusname;

    DBMS_AQADM.STOP_QUEUE(
        queue_name         => schedquename);
  exception
    when others then
       dbms_output.put_line('EXC: stopSchedQue');
    return;
  end;
---------------------------------
  procedure  stopDirectQue(dbusname  IN VARCHAR2) is
    directquename   VARCHAR2(100);
  begin
    directquename  := 'JEMUSER.DQ'   || dbusname;

    DBMS_AQADM.STOP_QUEUE(
        queue_name         => directquename);
  exception
    when others then
       dbms_output.put_line('EXC: stopDirectQue');
    return;
  end;
---------------------------------
  procedure  stopForeignQue(dbusname  IN VARCHAR2)  is
    foreignquename  VARCHAR2(100);
  begin
    foreignquename := 'JEMUSER.FQ'  || dbusname;
   
    DBMS_AQADM.STOP_QUEUE(
        queue_name         => foreignquename);
  exception
    when others then
       dbms_output.put_line('EXC: stopForeignQue');
    return;
  end;
---------------------------------
  procedure stopExceptionQue(dbusname  IN VARCHAR2)   is
    excquename      VARCHAR2(100);
  begin
    excquename     := 'JEMUSER.AQ$_QT' || dbusname || '_E';

    DBMS_AQADM.STOP_QUEUE( 
      queue_name         => excquename);
  exception
    when others then
       dbms_output.put_line('EXC: stopExceptionQue');
    return;
  end;
---------------------------------
  procedure  dropSubMatchQue(dbusname  IN VARCHAR2,
                subname   IN     VARCHAR2 DEFAULT  'JEMSUB')   is
    matchquename    VARCHAR2(100);
    subscriber   sys.aq$_agent;
  begin
    matchquename   := 'JEMUSER.MQ'    || dbusname;

    subscriber :=  
      sys.aq$_agent(subname || dbusname, null, null); 

    DBMS_AQADM.REMOVE_SUBSCRIBER(
      queue_name           => matchquename, 
      subscriber           => subscriber);
  exception
    when others then
       dbms_output.put_line('EXC: dropSubMatchQue');
    return;
  end;
---------------------------------
  procedure  dropSubSchedQue(dbusname  IN VARCHAR2,
                subname   IN     VARCHAR2 DEFAULT  'JEMSUB')     is
    schedquename    VARCHAR2(100);
    subscriber   sys.aq$_agent;
  begin
      schedquename   := 'JEMUSER.SQ'    || dbusname;

      subscriber :=  
        sys.aq$_agent(subname || dbusname, null, null); 

      --
      DBMS_AQADM.REMOVE_SUBSCRIBER(
        queue_name           => schedquename, 
        subscriber           => subscriber);
  exception
    when others then
       dbms_output.put_line('EXC: dropSubSchedQue');
    return;
  end;
---------------------------------
  procedure  dropSubDirectQue(dbusname  IN VARCHAR2,
                subname   IN     VARCHAR2 DEFAULT  'JEMSUB')  is
    directquename    VARCHAR2(100);
    subscriber   sys.aq$_agent;
  begin
      directquename   := 'JEMUSER.DQ'    || dbusname;

      subscriber :=  
        sys.aq$_agent(subname || dbusname, null, null); 

      --
      DBMS_AQADM.REMOVE_SUBSCRIBER(
        queue_name           => directquename, 
        subscriber           => subscriber);
  exception
    when others then
       dbms_output.put_line('EXC: dropSubDirectQue');
    return;
  end;
---------------------------------
  procedure  dropSubForeignQue(dbusname  IN VARCHAR2,
                subname   IN     VARCHAR2 DEFAULT  'JEMSUB')  is
    foreignquename    VARCHAR2(100);
    subscriber   sys.aq$_agent;
  begin
      foreignquename   := 'JEMUSER.FQ'    || dbusname;

      subscriber :=  
        sys.aq$_agent(subname || dbusname, null, null); 

      --
      DBMS_AQADM.REMOVE_SUBSCRIBER(
        queue_name           => foreignquename, 
        subscriber           => subscriber);
  exception
    when others then
       dbms_output.put_line('EXC: dropSubForeignQue');
    return;
  end;
---------------------------------
  procedure  dropMatchQue(dbusname  IN VARCHAR2) is
    matchquename    VARCHAR2(100);
  begin
    matchquename   := 'JEMUSER.MQ'    || dbusname;

    DBMS_AQADM.DROP_QUEUE( 
      Queue_name          => matchquename);
  exception
    when others then
       dbms_output.put_line('EXC: dropMatchQue');
    return;
  end;
---------------------------------
  procedure  dropSchedQue(dbusname  IN VARCHAR2)    is
    schedquename    VARCHAR2(100);
  begin
      schedquename   := 'JEMUSER.SQ'    || dbusname;

      DBMS_AQADM.DROP_QUEUE( 
        Queue_name          => schedquename);
  exception
    when others then
       dbms_output.put_line('EXC: dropSchedQue');
    return;
  end;
---------------------------------
  procedure  dropDirectQue(dbusname  IN VARCHAR2) is
    directquename    VARCHAR2(100);
  begin
      directquename   := 'JEMUSER.DQ'    || dbusname;  

      DBMS_AQADM.DROP_QUEUE( 
        Queue_name          => directquename);
  exception
    when others then
       dbms_output.put_line('EXC: dropDirectQue');
    return;
  end;
---------------------------------
  procedure  dropForeignQue(dbusname  IN VARCHAR2)  is
    foreignquename    VARCHAR2(100);
  begin
      foreignquename   := 'JEMUSER.FQ'    || dbusname;

      DBMS_AQADM.DROP_QUEUE( 
        Queue_name          => foreignquename);
  exception
    when others then
       dbms_output.put_line('EXC: dropForeignQue');
    return;
  end;
---------------------------------
  procedure  dropQueTable(dbusname  IN VARCHAR2)   is
    quetablename    VARCHAR2(100);
  begin
      quetablename   := 'JEMUSER.QT' || dbusname;

      DBMS_AQADM.DROP_QUEUE_TABLE(
        Queue_table            => quetablename);
  exception
    when others then
       dbms_output.put_line('EXC: dropQueTable');
    return;
  end;
---------------------------------
  procedure  dropQues(dbusname  IN VARCHAR2) is
  begin
    stopMatchQue(dbusname);
    stopSchedQue(dbusname);
    stopDirectQue(dbusname);
    stopForeignQue(dbusname);
    stopExceptionQue(dbusname);

    dropSubMatchQue(dbusname);
    dropSubSchedQue(dbusname);
    dropSubDirectQue(dbusname);
    dropSubForeignQue(dbusname);

    dropMatchQue(dbusname);
    dropSchedQue(dbusname);
    dropDirectQue(dbusname);
    dropForeignQue(dbusname);

    dropQueTable(dbusname);
  end;
---------------------------------
  procedure  dropTpcs(dbusname  IN VARCHAR2) is
  begin
    stopMatchQue(dbusname);
    stopSchedQue(dbusname);
    stopDirectQue(dbusname);
    stopForeignQue(dbusname);
    stopExceptionQue(dbusname);
    dropSubMatchQue(dbusname);
    dropSubSchedQue(dbusname);
    dropSubDirectQue(dbusname);
    dropSubForeignQue(dbusname);
    dropMatchQue(dbusname);
    dropSchedQue(dbusname);
    dropDirectQue(dbusname);
    dropForeignQue(dbusname);
    dropQueTable(dbusname);
  end;
---------------------------------

end  JEMDatabus;
/

------------------------------------------------------------

