
connect &1/&2 as sysdba

------------------------------------------------------------
 declare
   sqlstmt1  VARCHAR2(1000);
   sqlstmt2  VARCHAR2(1000);
   sqlstmt3  VARCHAR2(1000);
    err_num  NUMBER;
    err_msg  VARCHAR2(100);
 begin
   begin
     sqlstmt1 :=
       'drop user JEMuser cascade';

     execute immediate sqlstmt1;
   exception
      when others then null;
   end;

   begin
     sqlstmt2 :=
       'drop role JEMrole';

     execute immediate sqlstmt2;
   exception
      when others then null;
   end;

 end;
/

------------------------------------------------------------
 create role JEMrole;

------------------------------------------------------------
 create user JEMUSER identified by JEMPASSWD
    DEFAULT TABLESPACE  &4;

------------------------------------------------------------
------------------------------------------------------------

call dbms_java.grant_permission('JEMUSER', 'oracle.aurora.security.JServerPermission', 'LoadClassInPackage.oracle.aurora.*', null);

--
 grant create database link, create sequence, create session,
       create synonym, create public synonym, drop public synonym,
       create table, create view, create indextype,
       create procedure, create trigger, create type, 
       unlimited tablespace
    to  JEMUSER;

 grant aq_administrator_role      to  JEMUSER;
 grant execute on sys.dbms_aqadm  to  JEMUSER;
 grant execute on sys.dbms_aq     to  JEMUSER;

 grant execute on sys.dbms_aqin   to  JEMUSER;
 grant execute on sys.dbms_aqjms  to  JEMUSER;

 grant force any transaction      to  JEMUSER;

------------------------------------------------------------
 create table  JEMUSER.TabSystem
   (instid   VARCHAR2(50));

 --
  declare
    instid       VARCHAR2(50);
  begin
    select UPPER(INSTANCE_NAME) into instid from v$instance;

    --
    insert into  JEMUSER.TabSystem                   
	     (instid)
             values    
             (instid);

    commit;
  end;
/

------------------------------------------------------------