<?xml version="1.0"?>
<!-- Stylesheet that transforms any xml data and returns its
     equivalent SOAP message -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                              xmlns:transform="com.sun.xml.messaging.saaj.util.transform" 
                              exclude-result-prefixes="transform">
 <xsl:output encoding="UTF-8" media-type="text/xml" indent="yes"/>

  <xsl:template match="/">
    <SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" >
      <SOAP-ENV:Header>
      </SOAP-ENV:Header>
      <SOAP-ENV:Body>            
       <!-- apply the template to all children of the root node -->
       <xsl:apply-templates/>
      </SOAP-ENV:Body>
    </SOAP-ENV:Envelope>
  </xsl:template>

  <!-- copy all nodes, elements, attributes -->
  <xsl:template match="* | @*"> 
          <!-- check if prefix is same as SOAP-ENV -->
          <xsl:copy>
                <xsl:apply-templates select="@* | node() "/>
                <xsl:variable name="prefix" select="name(.)" />
                <xsl:variable name="value" select="." />         
                <xsl:variable name="prefixfunc" 
                      select="transform:TransformUtil.prefix($prefix)"/>          
         </xsl:copy>         
  </xsl:template>

  <!-- default rule is not to copy comments, but we want to copy comments here -->
  <xsl:template match="comment()">
    <!-- FIX ME:do we want to copy comments -->
    <xsl:copy/>
  </xsl:template>
  
  <!-- detect if the document contains processing instructions
       By default in xslt, PI's are ignored -->
  <xsl:template match="processing-instruction()">
    <xsl:variable name="name" select="name(.)" />
    <xsl:variable name="value" select="." />
    <xsl:variable name="funvalue" 
                  select="transform:TransformUtil.pi($name, $value)"/>
  </xsl:template>
  
</xsl:stylesheet>