<xsl:stylesheet version="1.0"	
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xml:space="preserve">

  <xsl:output method="text" indent="no" />

  <!-- We carry this in from outside -->
  <xsl:param name="oracle.ds.v2.ejbgen.ejb.homeIf"/>
  <xsl:param name="oracle.ds.v2.ejbgen.ejb.remoteIf"/>
  <xsl:param name="oracle.ds.v2.ejbgen.ejb.package"/>

  <!-- Internally we use the variable instead. -->
  <xsl:variable name="homeIfClass" select="$oracle.ds.v2.ejbgen.ejb.homeIf"/>
  <xsl:variable name="remoteIfClass" select="$oracle.ds.v2.ejbgen.ejb.remoteIf"/>
  <xsl:variable name="packageName" select="$oracle.ds.v2.ejbgen.ejb.package"/>

  <xsl:template match="/">
    <xsl:apply-templates select="Service" />
  </xsl:template>

  <xsl:template match="Service">
/* Copyright (c) 2001, Oracle Corporation.  All rights reserved.  */

/*
   DESCRIPTION
    This file has been generated by Oracle 9i Web Services.

   NOTES
    other useful comments, qualifications, etc.
*/

package <xsl:value-of select="$packageName"/>;

import javax.ejb.EJBHome;
import javax.ejb.CreateException;
import java.rmi.RemoteException;

public interface <xsl:value-of select="$homeIfClass"/> extends EJBHome
{
  <!--
    |
    | Iterates over all the operations defined by the service
    |
   -->
  public <xsl:value-of select="$remoteIfClass"/> create() throws RemoteException, CreateException;
}
</xsl:template>

</xsl:stylesheet>
