<xsl:stylesheet version="1.0"	
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xml:space="preserve">

  <xsl:output method="text" indent="no"/>

  <!-- We carry this in from outside -->
  <xsl:param name="oracle.ds.v2.ejbgen.ejb.implClass"/>
  <xsl:param name="oracle.ds.v2.ejbgen.ejb.beanClass"/>
  <xsl:param name="oracle.ds.v2.ejbgen.ejb.homeIf"/>
  <xsl:param name="oracle.ds.v2.ejbgen.ejb.remoteIf"/>
  <xsl:param name="oracle.ds.v2.ejbgen.ejb.packagePath"/>

  <!-- Internally we use variable instead --> 
  <xsl:variable name="implClass" select="$oracle.ds.v2.ejbgen.ejb.implClass"/>
  <xsl:variable name="beanClass" select="$oracle.ds.v2.ejbgen.ejb.beanClass"/>
  <xsl:variable name="homeIfClass" select="$oracle.ds.v2.ejbgen.ejb.homeIf"/>
  <xsl:variable name="remoteIfClass" select="$oracle.ds.v2.ejbgen.ejb.remoteIf"/>
  <xsl:variable name="packagePath" select="$oracle.ds.v2.ejbgen.ejb.packagePath"/>


  <xsl:template match="/"><xsl:apply-templates select="Service" /></xsl:template>

  <xsl:template match="Service">#!/bin/sh

echo ""
echo "#"
echo "# compile EJB sources. Make sure ORACLE_HOME refers to the iAS installation location."
echo "#"
echo "javac -classpath ${ORACLE_HOME}/j2ee/home/ejb.jar:${ORACLE_HOME}/j2ee/home/lib/dsv2.jar:${ORACLE_HOME}/lib/xmlparserv2.jar -d classes \
      src/<xsl:value-of select="$packagePath"/>/<xsl:value-of select="$implClass"/>.java \
      src/<xsl:value-of select="$packagePath"/>/<xsl:value-of select="$beanClass"/>.java \
      src/<xsl:value-of select="$packagePath"/>/<xsl:value-of select="$remoteIfClass"/>.java \
      src/<xsl:value-of select="$packagePath"/>/<xsl:value-of select="$homeIfClass"/>.java"

javac -classpath ${ORACLE_HOME}/j2ee/home/ejb.jar:${ORACLE_HOME}/j2ee/home/lib/dsv2.jar:${ORACLE_HOME}/lib/xmlparserv2.jar -d classes \
      src/<xsl:value-of select="$packagePath"/>/<xsl:value-of select="$implClass"/>.java \
      src/<xsl:value-of select="$packagePath"/>/<xsl:value-of select="$beanClass"/>.java \
      src/<xsl:value-of select="$packagePath"/>/<xsl:value-of select="$remoteIfClass"/>.java \
      src/<xsl:value-of select="$packagePath"/>/<xsl:value-of select="$homeIfClass"/>.java

echo ""
echo "#"
echo "# Jar EJB"
echo "#"
echo "cd classes; jar cvf ../deploy/<xsl:value-of select="$remoteIfClass"/>Ejb.jar .; cd .."
cd classes
jar cvf ../deploy/<xsl:value-of select="$remoteIfClass"/>Ejb.jar .
cd ..


echo ""
echo "#"
echo "# Create EAR"
echo "#"
echo "cd deploy; jar cvf ../<xsl:value-of select="$remoteIfClass"/>App.ear .; cd .."
cd deploy
jar cvf ../<xsl:value-of select="$remoteIfClass"/>App.ear .;
cd ..

echo ""
echo "#"
echo "# To deploy to OC4J run the following command (replace *** with your password):"
echo "# java -jar admin.jar ormi://ehost-test.us.oracle.com admin **** -deploy -file <xsl:value-of select="$remoteIfClass"/>App.ear -deploymentName <xsl:value-of select="$remoteIfClass"/>App"


</xsl:template>

</xsl:stylesheet>
