/* $Header: WirelessClientResourceBundle.java 08-sep-2004.11:16:44 pilin Exp $ */

/* Copyright (c) 2002, 2004, Oracle. All rights reserved.  */

/*
   DESCRIPTION
    <short description of component this file declares/defines>

   PRIVATE CLASSES
    <list of private classes defined - with one-line descriptions>

   NOTES
    <other useful comments, qualifications, etc.>

   MODIFIED    (MM/DD/YY)
    pilin       09/08/04 - change &reg; to &amp;reg; 
    pilin       08/16/04 - update copyright 
    pilin       05/19/04 - add branding 
    pilin       05/22/03 - Adding exception messages for em schema reassociation
    rharihar    02/28/03 - for link disable message
    pilin       02/20/03 - change wireless web clipping to web clipping
    pilin       02/19/03 - adding SCRAPE
    rharihar    02/19/03 - to add default name
    pilin       01/23/03 - adding ui resources for scraping
    pilin       01/06/03 - adding save failed
    pilin       12/30/02 - adding button names for mobile xml as well 
                           as other goodies
    chpeck      12/13/02 - add resource
    pilin       12/11/02 - adding help
    chpeck      12/05/02 - chpeck_wcmanager
    chpeck      12/04/02 - fix resource bundle names
    chpeck      11/27/02 - Creation
 */

/**
 *  @version $Header: WirelessClientResourceBundle.java 08-sep-2004.11:16:44 pilin Exp $
 *  @author  chpeck  
 *  @since   release specific (what release of product did this appear in)
 */

package oracle.panama.wcs.resource;

import java.util.ListResourceBundle;
/** 
 * Class contains the global resources 
 */
public class WirelessClientResourceBundle extends ListResourceBundle
{
  public Object[][] getContents() { return contents; }

  static final Object[][] contents = {

    // Used in the GUI of Web Clipping Manager, Studio, ...
    {"WEBTOOL",    "Web Tool"},
    {"HELP",       "Help"},
    {"OK",         "OK"},
    {"CANCEL",     "Cancel"},
    {"CONTINUE",   "Continue"},
    {"SCRAPE",     "Scrape"},
    {"APPLY",      "Apply"},
    {"WC_MANAGER", "Web Clipping Manager"},
    {"WC_STUDIO",  "Web Clipping Studio"},

    // Used in OHW for branding
    {"STUDIO_HELP_BRANDING", "Oracle Application Server Wireless Web Clipping"},

    // Used for Scraping UI
    {"SELECTED_ELEMENTS",  "Selected Elements"},
    {"MOBXML_BUTTON_MORE", "More"},
    {"MOBXML_BUTTON_LESS", "Less"},
    
    // Used for Mobile XML renderings
    {"MOBXML_BUTTON_NEXT",         "Next"},
    {"MOBXML_BUTTON_PREV",         "Prev"},
    {"MOBXML_BUTTON_HOME",         "Home"},
    {"MOBXML_LINK_CUSTOMIZE",      "Change Input"},
    {"MOBXML_COPYRIGHT",           "Copyright &amp;reg; 2003, 2004, Oracle Corporation. All Rights Reserved."},

    {"TABLE_HEADER_NAME",      "NAME"},
    {"TABLE_HEADER_VALUE",     "VALUE"},
    {"TABLE_HEADER_PATH",     "PATH"},
    {"DEFAULT_PARAM_NAME",     "Default_Name_For_"},

    {"MOBXML_ERROR_TITLE",         "Error"},
    {"MOBXML_NO_CUSTOMIZABLE_PARAMS", "There are no customizable parameters for this Web Clipping."},
    {"MOBXML_NO_CLIPDEF_FOUND_ID", "No Web Clipping with the Identifier {0} found. Please change the Id in your request to an existing Clip Id or create a new one using the Web Clipping Studio."},
    {"MOBXML_INVALID_RENDER_REQUEST", "Invalid render request for a Web Clipping: {0}."},
    {"MOBXML_INVALID_RENDER_RESPONSE_TYPE", "Invalid render request for a Web Clipping: Wrong or missing render response type: {0}."},

    {"WIRELESS_CLIENT_LINK_DISABLE",    "links are disabled in scrape mode."},

    {"WIRELESS_SHOW_CLIP_NOT_FOUND",    "The desired Web Clipping cannot be found anymore, possibly because the page has changed too drastically. Re-create the Web Clipping in the Studio."},
    {"WIRELESS_SHOW_CLIP_CHECK_FAILED", "The signature of the Clip has drastically changed. Please re-create the Web Clipping."},
    {"WIRELESS_SHOW_CLIP_TIMED_OUT",    "The connection timed out while accessing the remote Web site containing the clip. Increase your timeout value to adjust for a slow server. Also, check your proxy settings or make sure that the remote site is up."},
    {"WIRELESS_SHOW_UNEXPECTED_ERROR",  "An unexpected error has occured in rendering the Web Clipping. Please contact your administrator with the error message given: {0}."},
    {"WIRELESS_STUDIO_SAVE_FAILED",  "Failed to save the Clipping Defintion in the Web Clipping Repository. Nested Exception message: {0}."},
    {"WIRELESS_STUDIO_PERFORMACTION_FAILED",  "Failed to perform Web Clipping Studio Action. Nested Exception message: {0}."},
    {"WIRELESS_STUDIO_INIT_FAILED",  "Failed to initialize Web Clipping Studio. Nested Exception message: {0}."},

    {"ERROR_EM_SCHEMA_REASSOC_EXCEPTION", "An exception occured during Schema Reassociation; the message is {0}."},
  };
}
