<%@ page language="java" session="false"                            
         contentType="text/html;charset=utf-8"                       
         import="java.io.*,                                           
                 java.util.*,                                        
                 javax.naming.*,                                     
                 javax.resource.*,                                   
                 javax.resource.cci.*" %>
<%!
  /* $(COPYRIGHT)  */

  /*
     DESCRIPTION
      This file has been generated from the Web Clipping Support to execute
      the clip from a JSP

      Clip Title: $(CLIP_TITLE)

      Clip Description: $(CLIP_DESCRIPTION)
   */

  /**          
   * This method prints the Response Record in a pretty way as well as shows
   * how to use the Record that returns from the call to execute.
   *
   * @param resp   The response Record that is to be printed
   * @param tab    The starting tab (for View Source's sake)
   * @param writer The JSP Writer to call print on.
   */
   private static void writeFormatted(Record resp,
                                      String tab, 
                                      JspWriter writer)
     throws IOException
   {   
     // Print the record name first
     writer.print(tab+"<li><b>"+resp.getRecordName()+": </b>");

     if (resp instanceof List) {

       // Scroll through the result and recursively print every element.
       for (int i=0; i<((List)resp).size(); i++) {
         Object o = ((List)resp).get(i);
         if (o instanceof Record) {
           writer.println("\n"+tab+"<ul>");
           writeFormatted((Record)o, tab+"\t", writer);
           writer.println("\n"+tab+"</ul>");
         } else {
           writer.print("<i>"+String.valueOf(o)+"</i>");
         }
       }
     }
   }
%>

<% request.setCharacterEncoding("UTF-8"); %>

<html>
  <head><title>$(CLIP_TITLE)</title></head>
  
  <body>
    <h1>$(CLIP_TITLE)</h1>
    
    <FORM method="POST" name="TestForm">
    <INPUT type="hidden" name="id" value="$(CLIP_ID)">
      <TABLE>
        <TR>
          $(CLIP_CUST_PARAMS_IN_HTML)
          <TD><INPUT type="submit" name="Submit" value="Test Clip"></TD>
        </TR>
      </TABLE>
    </FORM>

    <%
      InitialContext ic = new InitialContext();
      ConnectionFactory cf = (ConnectionFactory)ic.lookup("eis/webclipping"); 
      //
      // Now everything is pure CCI
      //
      Connection conn = cf.getConnection();               // Get a connection
      Interaction interaction = conn.createInteraction(); // To execute 
      RecordFactory recFact = cf.getRecordFactory();      // Create Records   
      //
      // The following two entries are put using reserved keys
      //
      MappedRecord recIn = recFact.createMappedRecord("Default"); // Input
      recIn.put("oracle.webclipping.clip.id", "$(CLIP_ID)");      // Clip ID
      recIn.put("oracle.webclipping.servlet.request", request);   // Headers  
      $(CLIP_CUST_PARAMS_IN_JAVA)
      // Don't need the Interaction Spec so we won't need our classes
      Record recOut = interaction.execute(null, recIn);
    %>      
    <h3>Execution Results</h3>
    <ul>
    <!-- Print out the record; use our generic print -->
    <% writeFormatted(recOut, "  ", out); %>
    </ul>
    <hr>
  </body> 
</html>
