@echo off
rem 
rem startup.bat - Startup script for for pre-configured Portal Tools and JPDK
rem               Web Providers OC4J bundle.    
rem 
rem This script starts the demo bundle OC4J instance.  Please set the
rem JAVA_HOME environment variable to point at your JDK installation
rem before running this script.
rem

rem -- Make sure JAVA_HOME is set
if not "%JAVA_HOME%" == "" goto run

rem -- JAVA_HOME isn't set - warn and exit
echo Please set the JAVA_HOME environment variable to point at your JDK
goto done


:run

set JAVA="%JAVA_HOME%\bin\java.exe"

rem -- Make sure that the java executable exists
if exist %JAVA% goto run2

rem -- The java executable does not exist - warn and exit.
echo The executable file %JAVA% was not found.
echo Make sure that your JAVA_HOME environment variable is pointing to the
echo correct directory.
goto done

:run2

rem -- For some users, these directories weren't created when they
rem -- unzipped, which made OC4J unhappy.  Make sure they exist!
if exist ..\j2ee\home\persistence goto run3

mkdir ..\j2ee\home\persistence
mkdir ..\j2ee\home\persistence\ejb

:run3


echo Starting OC4J...

%JAVA% -jar -Xmx256M -Xms64M ..\j2ee\home\oc4j.jar -config ..\j2ee\home\config\server.xml
set JAVA=

:done

rem -- We're done!
