package faqapp;

import java.util.Collection;
import javax.ejb.CreateException;
import javax.ejb.EJBLocalHome;
import javax.ejb.FinderException;

/**
 * This is the AreaBean's Local Home interface
 *
 * One create() method which corresponds to the ejbCreate() in bean class.
 **/
public interface AreaLocalHome extends EJBLocalHome {
    /**
     * Creates an Area
     * @param areaDesc: area description
     * @return the newly created EJB Local Object.
     **/
    public AreaLocal create(String areaDesc) throws CreateException;

    /**
     * Finder methods. These are implemented by the container. We can
     * customize the functionality of these methods in the deployment
     * descriptor through EJB-QL.
     **/
    public AreaLocal findByPrimaryKey(Integer key) throws FinderException;

    public Collection findAll() throws FinderException;
}
