package faqapp;

import java.util.Collection;
import javax.ejb.CreateException;
import javax.ejb.EJBLocalHome;
import javax.ejb.FinderException;

/**
 * This is the TopicBean's Local Home interface
 *
 * One create() method which corresponds to the ejbCreate() in bean class.
 **/
public interface TopicLocalHome extends EJBLocalHome {
    /**
     * Creates a Topic
     * @param topicDesc: topic description
     * @param area: the associated area
     * @return the newly created EJB Local Object.
     **/
    public TopicLocal create(String topicDesc, AreaLocal area) throws CreateException;

    /**
     * Finder methods. These are implemented by the container. We can
     * customize the functionality of these methods in the deployment
     * descriptor through EJB-QL.
     **/
    public TopicLocal findByPrimaryKey(Integer key) throws FinderException;

    public Collection findByAreaID(Integer areaID) throws FinderException;

    public Collection findAll() throws FinderException;
}
