package faqapp.struts.forms;

import java.io.Serializable;
import org.apache.struts.action.ActionForm;

/**
 * Abstract implementation of Struts action form bean.
 * This form has the following fields that are common across all FAQApp Form beans:
 * <ul>
 * <li><b>id</b> - Auto-generated object ID (Area/Topic/FAQ)
 * <li><b>action</b> - Form action (create/update/save/query)
 * </ul>
 */
public abstract class FAQAbstractForm extends ActionForm implements Serializable {
    private int id = 0;
    private String action = "";

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getAction() {
        return action;
    }

    public void setAction(String action) {
        this.action = action;
    }

    public void reset() {
        this.id = 0;
        this.action = "";
    }
}

