import javax.naming.Context;
import javax.naming.InitialContext;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueReceiver;
import javax.jms.QueueSender;
import javax.jms.QueueSession;
import javax.jms.Session;
import javax.jms.StreamMessage;
import javax.jms.*;


public final
class Qsend
{
    public static void main(String[] argv)
    {
        try
        {
            if ((argv.length != 3)
                && (argv.length != 5))
            {
                System.err.println("Usage: Qsend <qcfN> <qN>"
                    + " <nmsgs> [<user> <pass>]]");
                return;
            }

            int argc = 0;

            String qcfN  = argv[argc++];
            String qN    = argv[argc++];
            int    nmsgs = Integer.parseInt(argv[argc++]);

            String user  = null;
            String pass  = null;

            if (argv.length == 5)
            {
                user    = argv[argc++];
                pass    = argv[argc++];
            }

            doit(qcfN, qN, user, pass, nmsgs, false);
            //doit(qcfN, qN, user, pass, nmsgs, true);
            System.out.println("\n\n");
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }

    }

    public static void doit(String qcfN, String qN,
        String user, String pass, int nmsgs, boolean transacted)
    {
        try
        {
            QueueConnectionFactory qcf =
                (QueueConnectionFactory) Oc4jjmsDemo.getQCF(qcfN);
            Queue q = (Queue) Oc4jjmsDemo.getQ(qN);

            do_send(qcf, q, user, pass, nmsgs, transacted);
        }
        catch (JMSException e)
        {
            e.printStackTrace();
            if (e.getLinkedException() != null)
            {
                e.getLinkedException().printStackTrace();
            }
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    private static void do_send(QueueConnectionFactory qcf, Queue q,
        String user, String pass, int nmsgs, boolean transacted)
        throws Exception
    {
        System.out.println("starting do_send");

        QueueConnection qc  = Oc4jjmsDemo.getQC(qcf, user, pass);
        QueueSession    qs  = qc.createQueueSession(transacted,
            Session.AUTO_ACKNOWLEDGE);
        QueueSender     snd = qs.createSender(q);


        qc.start();

        for (int i = 0; i < nmsgs; ++i)
        {
            Message msg = qs.createMessage();

            snd.send(msg);
            System.out.println("msg:"
                + " id=" + msg.getJMSMessageID());
        }

        if (transacted)
            qs.commit();

        snd.close();
        qs.close();
        qc.close();

        System.out.println("ending do_send");
    }
}
