import java.util.Enumeration;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.Queue;
import javax.jms.QueueBrowser;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueSender;
import javax.jms.QueueSession;
import javax.jms.Session;
import javax.jms.StreamMessage;


public final
class Qbrow
{
    public static void main(String[] argv)
    { 

        try
        {
            if ((argv.length != 3)
                && (argv.length != 5))
            {
                System.err.println("Usage: Qbrow <qcfN> <qN>"
                    + " <nmsgs> [<user> <pass>]]");
                return;
            }

            int argc = 0;

            String qcfN  = argv[argc++];
            String qN    = argv[argc++];
            int    nmsgs = Integer.parseInt(argv[argc++]);

            String user  = null;
            String pass  = null;

            if (argv.length == 5)
            {
                user    = argv[argc++];
                pass    = argv[argc++];
            }

            doit(qcfN, qN, user, pass, nmsgs, false);
            //doit(qcfN, qN, user, pass, nmsgs, true);
            System.out.println("\n\n");
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }

    }

    public static void doit(String qcfN, String qN,
        String user, String pass, int nmsgs, boolean transacted)
    {
        try
        {
            QueueConnectionFactory qcf =
                (QueueConnectionFactory) OjmsDemo.getQCF(qcfN);
            Queue q = (Queue) OjmsDemo.getQ(qN);

            do_browse(qcf, q, user, pass, nmsgs, transacted);
        }
        catch (JMSException e)
        {
            e.printStackTrace();
            if (e.getLinkedException() != null)
            {
                e.getLinkedException().printStackTrace();
            }
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    private static void do_browse(QueueConnectionFactory qcf, Queue q,
        String user, String pass, int nmsgs, boolean transacted)
        throws Exception
    {
        System.out.println("starting do_browse");

        QueueConnection qc  = OjmsDemo.getQC(qcf, user, pass);
        QueueSession    qs  = qc.createQueueSession(transacted,
            Session.AUTO_ACKNOWLEDGE);
        QueueBrowser    qb  = qs.createBrowser(q);

        qc.start();

        int count = 0;

        Enumeration e = qb.getEnumeration();
        while (e.hasMoreElements())
        {
            Message msg = (Message) e.nextElement();
            System.out.println("msg:"
                + " id=" + msg.getJMSMessageID());
            ++count;
        }

        if (nmsgs != count)
        {
            System.out.println("expected: " + nmsgs + " found: " + count);
        }

        qb.close();
        qs.close();
        qc.close();

        System.out.println("ending do_browse");
    }
}
