<xsl:stylesheet
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    version="1.0" >

<xsl:output
     method="xml"
     indent="yes" 
     encoding="ISO-8859-1"
     doctype-public="-//Sun Microsystems, Inc.//DTD JSP Tag Library 1.2//EN"
     doctype-system="http://java.sun.com/dtd/web-jsptaglibrary_1_2.dtd"
/>

<!-- Purpose: Converts 1.1 Taglibrary Descriptors to 1.2 -->
<!-- run an xslt program such as
java oracle.xml.parser.v2.oraxsl -v -w -debug your11.tld jsptld_11_2_12.xsl > new12.tld
 or
java org.apache.xalan.xslt.Process -in your11.tld -xsl jsptld_11_2_12.xsl -out  new12.tld
-->
<!-- Put the xslt program in your classpath and make sure a copy of 
     web-jsptaglibrary_1_1.dtd is accessible, either in the current directory
     if your .tld contains a local reference, or via the web if your
     .tld's DOCTYPE is PUBLIC with the full url to the taglib dtd.
     If you are behind a firewall supply your http proxy host and port, 
     for example:
     java -Dhttp.proxyHost=myproxy.com -Dhttp.proxyPort=80 ....
-->

<xsl:template match="*[local-name()='taglib']">
    <xsl:element name="taglib" > 
        <xsl:apply-templates /> 
    </xsl:element > 
</xsl:template>

<xsl:template match="*[local-name()='tlibversion']" >
   <xsl:element name="tlib-version" >
        <xsl:copy-of select="@*" />
        <xsl:apply-templates />
    </xsl:element>
</xsl:template>

<xsl:template match="*[local-name()='jspversion']" >
    <xsl:element name="jsp-version" >
        <xsl:copy-of select="@*" />1.2</xsl:element>
</xsl:template>

<xsl:template match="*[local-name()='shortname']" >
    <xsl:element name="short-name" >
        <xsl:copy-of select="@*" />
        <xsl:apply-templates />     
    </xsl:element>
</xsl:template>

<xsl:template match="*[local-name()='tagclass']" >
    <xsl:element name="tag-class" >
        <xsl:copy-of select="@*" />
        <xsl:apply-templates />     
    </xsl:element>
</xsl:template>

<xsl:template match="*[local-name()='teiclass']" >
    <xsl:element name="tei-class" >
        <xsl:copy-of select="@*" />
        <xsl:apply-templates />     
    </xsl:element>
</xsl:template>

<xsl:template match="*[local-name()='bodycontent']" >
    <xsl:element name="body-content" >
        <xsl:copy-of select="@*" />
        <xsl:apply-templates />     
    </xsl:element>
</xsl:template>

<xsl:template match="*[local-name()='info']" >
    <xsl:element name="description" >
        <xsl:copy-of select="@*" />
        <xsl:apply-templates />     
    </xsl:element>
</xsl:template>

<xsl:template match="comment()" >
  <xsl:comment >
      <xsl:value-of select="." />
  </xsl:comment >
</xsl:template>

<xsl:template match="processing-instruction('*')" >
  <xsl:processing-instruction  name='{local-name()}'>
    <xsl:value-of select="." />
  </xsl:processing-instruction>
</xsl:template>

<xsl:template match="*" priority="-1" >
    <xsl:element name="{local-name()}" >
        <xsl:copy-of select="@*" />
        <xsl:apply-templates />     
    </xsl:element>
</xsl:template>

</xsl:stylesheet >
